if (typeof(simplemail) == "undefined")
  var simplemail = {a: "main.js"};

simplemail.SimpleMailMain = function() {
  var pub = {};

  pub.initialize = function() {
    if (initialized) 
      return;
    initialized = true;

    // userok: drop obsolete simplemail.domRemove("gr/ippy-style");
    simplemail.SimpleMailMain.initToolbarMode();
    
    // Important: Do not allow mail messages to execute javascript,
    // Because this javascript would be executed with chrome privileges
    simplemail.domGet("body").docShell.allowJavascript    = false;
    simplemail.domGet("printer").docShell.allowJavascript = false;
    
    simplemail.domGet("body").contentDocument.addEventListener("keypress", function(evt) {
      if (!evt.ctrlKey || String.fromCharCode(evt.charCode) != 'a') {
        simplemail.messageTreeView.onKeyPress(evt);
      }
    }, false);
    
    simplemail.overlay = simplemail.getBrowserWindow().simplemail.overlay;
    //console.error("SM.SimpleMailMain_initialize", simplemail.overlay, this);//userok_log
    
    SimpleMail_updateFavIcon();
    
    messages         = [];
    messageTree      = simplemail.domGet("message-tree");
    messageTree.view = simplemail.messageTreeView;
    
    folders         = simplemail.overlay.storage.getFolders();
    folderTree      = simplemail.domGet("folder-tree");
    folderTree.view = simplemail.folderTreeView;
    simplemail.SimpleMailAdresses.initAddresses();
    //console.error("SM.SimpleMailMain_initialize", folders, this);//userok_log
    
    if (simplemail.SimpleMailPrefs.getBool("nospam")) {
      simplemail.domGet("asspam").hidden = true;
      simplemail.domGet("spam").hidden   = true;
    } else
      simplemail.domGet("spam").hidden   = false;
     
    simplemail.SimpleMailManageFolder.displayInbox();
    
    var browserWindow = simplemail.getBrowserWindow();
    var tabContainer  = browserWindow.getBrowser().selectedTab;
    tabContainer.addEventListener("TabClose", simplemail.SimpleMailMain.onTabClose, false);
    
    // userok
    simplemail.domGet("buttonblockmedia").checked = simplemail.SimpleMailPrefs.getBool('blockmedia');
    /*var stat = simplemail.overlay.get/Status(); // from 2.86.7
    if (stat == "loading") {
      var counter = 10;
      simplemail.SimpleMailMain.showProgress(counter);
    }*/
  },

  pub.showProgress = function(counter) {
    //var stat = simplemail.overlay.get/Status(); // userok
    //if (stat == "loading") {                              // userok
    if (simplemail.overlay.instances.length) {    // userok
      counter = counter + 5;
      if (counter == 105)
        counter = 0;

      var win = simplemail.overlay.getMainWindow();
      win.document.getElementById("progressMeter").collapsed  = false; 
      win.document.getElementById("cancelcheck").hidden       = false;
      win.document.getElementById("progressMeterText").hidden = false;
      win.document.getElementById("progressMeter").value      = counter;
      simplemail.overlay.updateIcons();
      setTimeout(function() {
        simplemail.SimpleMailMain.showProgress(counter);
      }, 100);
    }
  },

  pub.switchLayout = function() {
    var orient = (simplemail.domGet("right-column").orient == "horizontal") ? "vertical" : "horizontal";
    simplemail.domGet("right-column").orient   = orient;
    simplemail.domGet("right-splitter").orient = orient;
  },

  pub.switchHeaders = function() {
    simplemail.domGet("headers").collapsed = !simplemail.domGet("headers").collapsed;
  },
      
  pub.initToolbarMode = function() {
    var mode = simplemail.SimpleMailPrefs.getString("toolbarMode");
    simplemail.domGet("simplemail-toolbar").setAttribute("mode", mode);

    var menuitems = simplemail.domGet("toolbar-menu").childNodes;
    for (var i = 0; i < menuitems.length; i++) {
      if (menuitems[i].value == mode)
        menuitems[i].setAttribute("checked", true);
    }
    if (simplemail.SimpleMailPrefs.getBool("old")) {
      simplemail.domRemove("nuvola-style");
      simplemail.domRemove("oxygen-style");
      simplemail.domRemove("australis-style");
    } else if (simplemail.SimpleMailPrefs.getBool("nuvola")) {
      simplemail.domRemove("old-style");
      simplemail.domRemove("oxygen-style");
      simplemail.domRemove("australis-style");
    } else if (simplemail.SimpleMailPrefs.getBool("oxygen")) {
      simplemail.domRemove("old-style");
      simplemail.domRemove("nuvola-style");
      simplemail.domRemove("australis-style");
    } else if (simplemail.SimpleMailPrefs.getBool("australis")) {
      simplemail.domRemove("old-style");
      simplemail.domRemove("nuvola-style");
      simplemail.domRemove("oxygen-style");
    }
    // userok
    var menuitems = simplemail.domGet("toolbar-menu-buttons").childNodes;
    for (var i = 0; i < menuitems.length; i++) {
      var visible = !simplemail.SimpleMailPrefs.getBool("toolbar-" + menuitems[i].value + "-hidden");
      var btn     = simplemail.domGet(menuitems[i].value);
      if (btn) {
        menuitems[i].setAttribute("checked", visible);
        btn.setAttribute("hidden", !visible);
      }
    }
  },

  pub.updateToolbarMode = function() {
    var menuitems = simplemail.domGet("toolbar-menu").childNodes;
    for (var i = 0; i < menuitems.length; i++) {
      if (menuitems[i].getAttribute("checked")) {
        simplemail.SimpleMailPrefs.setString("toolbarMode", menuitems[i].value);
        simplemail.domGet("simplemail-toolbar").setAttribute("mode", menuitems[i].value);
      }
    }
    // userok
    var menuitems = simplemail.domGet("toolbar-menu-buttons").childNodes;
    for (var i = 0; i < menuitems.length; i++) {
      var visible = menuitems[i].getAttribute("checked");
      var btn     = simplemail.domGet(menuitems[i].value);
      if (btn) {
        simplemail.SimpleMailPrefs.setBool("toolbar-" + menuitems[i].value + "-hidden", !visible);
        btn.setAttribute("hidden", !visible);
      }
    }
  },
  
  pub.archiveFolder = function() {
    var param = {
        inn: {
          folder:     simplemail.SimpleMailManageFolder.getCurrentFolder(), 
          folders:    simplemail.overlay.storage.getFolders(), 
          folderTree: simplemail.domGet("folder-tree")}, 
        out: null};

    openDialog("chrome://simplemail/content/archive.xul", "simplemail-archive-window", "chrome,modal,centerscreen,resizable", param);
    if (param.out) {
      folders         = simplemail.overlay.storage.getFolders();
      folderTree      = simplemail.domGet("folder-tree");
      folderTree.view = simplemail.folderTreeView;
      simplemail.SimpleMailManageFolder.updateFolderCounts();
      simplemail.SimpleMailManageFolder.displayInbox();
      simplemail.messageTreeView.displayFolder();
    }
  },
  
  pub.openSPAMOptions = function() {
    if (!simplemail.overlay.spamWindow || simplemail.overlay.spamWindow.closed) {
      var param = {
        inn: {
          folder:          simplemail.SimpleMailManageFolder.getCurrentFolder(), 
          folders:         simplemail.overlay.storage.getFolders(), 
          folderTree:      simplemail.domGet("folder-tree"), 
          folderTreeView:  simplemail.folderTreeView, 
          messageTreeView: simplemail.messageTreeView}, 
        out: null};
        
      simplemail.overlay.spamWindow = openDialog("chrome://simplemail/content/preferences/spamprefs.xul",
        "simplemail-spam-window", "chrome,modal,centerscreen,resizable", param);
    } else 
      simplemail.overlay.spamWindow.focus();
  },
  
  pub.onTabClose = function(event) {
    if (event.target.linkedBrowser.contentDocument == document) 
      simplemail.SimpleMailMain.onClose();
  },
  
  pub.onUnload = function() {
    var browserWindow = simplemail.getBrowserWindow();
    if (browserWindow !== null) {
      var tabContainer = browserWindow.getBrowser().selectedTab;
      tabContainer.removeEventListener("TabClose", simplemail.SimpleMailMain.onTabClose, false);
    }
  },
  
  pub.onClose = function() {
    if (simplemail.SimpleMailPrefs.getBool('cleanonexit')) 
      simplemail.SimpleMailMain.emptyOnExit();
    if (simplemail.overlay.openedWindows.length > 0) {
      for (var i = 0; i < simplemail.overlay.openedWindows.length; i++)
        simplemail.overlay.openedWindows[i].close();
    }
    // userok: async
    if (simplemail.SimpleMailPrefs.getBool('cleandatabase')) {
      simplemail.overlay.storage.doCleanDataBase(function () {
        simplemail.showAlertNotification('Done..', 'SimpleMail: VACUUM', 'chrome://simplemail/skin/status/mail_std_large.png');
      });
    }
  },  
  
  pub.emptyOnExit = function() {
    if (!simplemail.SimpleMailManageFolder.isTrashEmpty()) {
      var tfolders = simplemail.overlay.storage.getFolders();
      for (var i in tfolders) {
        var children = tfolders[i];
        for (var j in children) {
          if (children[j].id == simplemail.Folder.TRASH) {
            var folderTrash = children[j];
            break;
          }
        }
      }
      
      simplemail.SimpleMailManageFolder.askDeleteFolder(folderTrash, simplemail.Bundle.getString("emptyTrash"), true, true);
    }
  }
  
  return pub;
}();               