var SimpleMailVCard = {
  export: function(storage) {
    var file = simplemail.SimpleMailFile.chooseFile("save", ["*.vcf"]);
    if (!file) return;

    if (!file.leafName.match(/\.vcf/)) {
      file.leafName += ".vcf";
    }
    var data      = "";
    var addresses = storage.getAddresses();

    for (var i = 0; i < addresses.length; i++) {
      var address = addresses[i];
      data += "BEGIN:VCARD\r\n" +
              "UID:" + address.id + "\r\n" +
              "N:" + address.name + "\r\n" +
              "FN:" + address.name + "\r\n" +
              "TEL;WORK:" + address.phone + "\r\n" +
              "ADR;WORK:" + address.postaladdress + "\r\n" +
              (address.group ? "SM.GROUP:" + address.group
                             : "EMAIL:" + address.email) + "\r\n" +
              (address.favorite ? "SM.FAVORITE:" + address.favorite + "\r\n" : "") +
              "END:VCARD\r\n";
    }
    simplemail.SimpleMailFile.writeFile(file, data, true);
  },

  getByRegexp: function(text, regexp) {
    var match = regexp.exec(text);
    return match && match[1];
  },

  // userok: async (import vcard to addressbook and refresh it)
  import: function(storage) {
    var file = simplemail.SimpleMailFile.chooseFile("open", ["*.vcf"]);
    if (!file) 
      return;

    var data        = simplemail.SimpleMailFile.readFile(file, true);
    var cards       = data.split("BEGIN:VCARD");
    var addresses   = new Array();
    var cardsUnDone = cards.length - 1; // userok

    for (var i = 0; i < cards.length; i++) {
      var card = cards[i];
      if (card) {
        // userok: async
        var id                      = SimpleMailVCard.getByRegexp(card, /UID.*:(.*)/) || simplemail.getUniqueId();
        addresses[id]               = new simplemail.Address();
        addresses[id].name          = SimpleMailVCard.getByRegexp(card, /FN.*:(.*)/);
        addresses[id].email         = SimpleMailVCard.getByRegexp(card, /EMAIL.*:(.*)/);
        addresses[id].phone         = SimpleMailVCard.getByRegexp(card, /TEL.*:(.*)/);
        addresses[id].postaladdress = SimpleMailVCard.getByRegexp(card, /ADR.*:(.*)/);
        addresses[id].group         = SimpleMailVCard.getByRegexp(card, /SM.GROUP.*:(.*)/);
        addresses[id].favorite      = SimpleMailVCard.getByRegexp(card, /SM.FAVORITE.*:(.*)/);          
        //console.error("SM.vcard_import: ", id, addresses[id]);//userok_log
        // userok: async
        storage.saveAddress(function (addr) {
          // Translate group ids
          if (addr.group) {
            var ids = addr.group.split(",");
            for (var j = ids.length - 1; j >= 0; j--) {
              var id = ids[j];
              if (addresses[id]) {
                ids[j] = addresses[id].id;
              } else 
                ids.splice(j, 1);
            }
            addr.group = ids.join(",");
            storage.saveAddress(addr);
          }
          // check done
          cardsUnDone--;
          if (!cardsUnDone)
             simplemail.SimpleMailAdresses.initAddresses();
          // log
          //console.error("SM.vcard_import.done: ", addr, cardsUnDone);//userok_log
        }, addresses[id]);
      }
    }
  }
}