if (typeof(simplemail) == "undefined")
  var simplemail = {a: "overlay.js"};

simplemail.overlay = function() {
  var pub = {addonVersion: "2.91", URL: "chrome://simplemail/content/main/main.xul", storage: null, tmp: []}; //userok
  //console.error("SM.overlay()", this);//userok_log
  
  // userok: async
  pub.preinitialize = function() {
    //console.error("SM.overlay_preinitialize", this, simplemail, window);//userok_log
    // init storage
    simplemail.overlay.storage = new simplemail.Storage();
    simplemail.overlay.storage.initStorage(function() {
      // init accounts, folders, filters, addressbook
      simplemail.overlay.storage.doGetAccounts(function(taccounts) {
        simplemail.overlay.storage.dogetFolders(function(tfolders) {
          simplemail.overlay.storage.doGetFilters(function(tfilters) {
            simplemail.overlay.storage.dogetAddresses(function(tAddressBook) {
              simplemail.overlay.initialize();
            });
          });
        });
      });       
    });
  },
  
  pub.initialize = function() {
    //console.error("SM.overlay_initialize", simplemail);//userok_log
    var smurl        = "http://www.userlogos.org/extensions/simplemail/changelog";
    var addonVersion = simplemail.overlay.addonVersion;
    var firstRun     = simplemail.overlay.storage.firstRun;
    
    // add SM button for first run
    if (firstRun)
      simplemail.overlay.installSimpleMailIcon("nav-bar", "SimpleMailButton");
		
    // userok: handle Mailto links
    simplemail.overlay.handleMailto();
			
    // create welcome letter for first run and open userlogos when first run or update
    setTimeout(function() {
      if (firstRun) { // First Run
        simplemail.overlay.createWelcomeLetter();
        var gBrowser = simplemail.getBrowser();
        gBrowser.selectedTab = gBrowser.addTab(smurl);
        simplemail.SimpleMailPrefs.setString("version", addonVersion);
      } else {        // Update
        if (addonVersion !== simplemail.SimpleMailPrefs.getString("version")) {
          var gBrowser = simplemail.getBrowser();
          gBrowser.selectedTab = gBrowser.addTab(smurl);
          simplemail.SimpleMailPrefs.setString("version", addonVersion);
        }
      }
      
      // check mail on start and create autocheck timers
      if (simplemail.SimpleMailPrefs.getBool("checkOnStartup")) 
        simplemail.overlay.getMail();
      else {
        simplemail.overlay.lastCheckTime = new Date();
        var taccounts = simplemail.overlay.storage.getAccounts();
        for (var i in taccounts) {
          var account = taccounts[i];
          if (account.refresh > 0) {          
            var listener = new simplemail.overlay.GetMailListener(account);
            //userok
            simplemail.overlay.timeouts[account.id] = 
              setTimeout(function(accId) {
                //console.error("SM.overlay.initialize.accId", accId); //userok_log
                simplemail.overlay.getMail(accId);
              }, account.refresh * 60 * 1000, account.id);
          }
        }
        simplemail.overlay.updateIcons();
      }
    }, 50);

    simplemail.domGet("contentAreaContextMenu").addEventListener("popupshowing", simplemail.overlay.onContentMenuShowing, false);
  },

  pub.getMainWindow = function(initialized) {
    var gBrowser = simplemail.getBrowser();
    for (var i = 0; i < gBrowser.browsers.length; i++) {
      var browser = gBrowser.browsers[i];
      if (browser.currentURI.spec == simplemail.overlay.URL) {
        var wnd = browser.contentWindow.wrappedJSObject;
        if (!initialized || wnd.initialized)
          return wnd;
      }
    }
  },
  
  // userok: rewrited (Make "mailto:" URLs (un)handled by SM)
  pub.handleMailto = function() {
    var bHandle = simplemail.SimpleMailPrefs.getBool("handleMailto");
    var prefs   = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); // userok
    prefs.setBoolPref("network.protocol-handler.expose.mailto", bHandle);
    prefs.setBoolPref("network.protocol-handler.external.mailto", !bHandle);
  },
  
  // userok
  pub.setBlockMedia = function(checked) {
    //console.error("SM.setBlockMedia", checked);//userok_log
    simplemail.SimpleMailPrefs.setBool('blockmedia', checked);
    var mainWindow = simplemail.overlay.getMainWindow(true);
    if (mainWindow)
      mainWindow.simplemail.messageTreeView.displayMessageHtml();
  },
  
  // userok: rewrited
  pub.createWelcomeLetter = function() {
    var textbody     = "Content-Type: text/plain; charset=utf-8\r\n" + 
                       "From: Simple Mail <no-reply@localhost>\r\n" + 
                       "To: User <no-reply@localhost>\r\n" + 
                       "Subject: " + simplemail.Bundle.getString("welcomeMessageSubject") +
                       "!\r\n\r\n" + 
                       simplemail.Bundle.getString("welcomeMessageBody");
    var message      = simplemail.MessageParse(simplemail.SimpleMailText.fromUnicode(textbody, "utf-8"));
    message.date     = new Date();
    message.folderId = simplemail.Folder.INBOX;
    simplemail.overlay.addMessage(message);
  },
  
  pub.installSimpleMailIcon = function (toolbarId, buttonId) {
    if (!document.getElementById(buttonId)) {
      var toolbar = document.getElementById(toolbarId);
 
      toolbar.insertItem(buttonId, null, null, false);
      toolbar.setAttribute("currentset", toolbar.currentSet);
      document.persist(toolbar.id, "currentset");
    }
  },
  
  pub.isRunning = function() {
    return simplemail.overlay.instances.length;
  },

  pub.onClick = function(event) {
    if (event.button == 1) 
      simplemail.overlay.getMail();
    else if (!event.button) {
      if (event.type == "dblclick") 
        simplemail.overlay.stop();
      else 
        simplemail.overlay.open(event);
    }
  },

  pub.stop = function() {
    for (var i = 0; i < simplemail.overlay.instances.length; i++)
      simplemail.overlay.instances[i].stop();
  },

  pub.open = function(event) {
    var mainWindow = simplemail.overlay.getMainWindow();
    if (mainWindow) {
      if (mainWindow.initialized)
        mainWindow.simplemail.SimpleMailManageFolder.displayInbox();
    } else {
      var where = simplemail.whereToOpenLink(event);
      if (!where && !simplemail.SimpleMailPrefs.getBool("openInCurrentTab")) where = "tab";
      if (where == "window")
        where = "tabshifted";
      simplemail.openUILink(simplemail.overlay.URL, where);
    }
  },

  // userok: rewrited
  pub.openPreferences = function() {
    openDialog("chrome://simplemail/content/preferences/preferences.xul", "simplemail-preferences-window", "chrome,centerscreen,modal,resizable");
    var mainWnd = simplemail.overlay.getMainWindow();
    if (mainWnd)
      mainWnd.location.reload();
  },

  pub.mailWindow = null,
  pub.mailTab    = null,
  
  // userok: rewrited
  pub.openNewMessage = function(aMessage, mailto) {
    //console.error("SM.overlay_openNewMessage", aMessage, mailto);//userok_log
    var taccounts = simplemail.overlay.storage.getAccounts();
    if (!taccounts.length) 
      return;

    var LMessage = aMessage; // userok fix warning
    if (mailto) 
      LMessage = simplemail.MessageParseMailto(mailto);
    
    if (!LMessage) 
      LMessage = new simplemail.Message();

    var tId = simplemail.getUniqueId();
    simplemail.overlay.tmp[tId] = LMessage; //JSON.stringify(object) or JSON.parse(jsonString);
    
    var url = "chrome://simplemail/content/newmessage.xul?" + tId;
    if (simplemail.SimpleMailPrefs.getBool("newMessagesInWindow")) {
      simplemail.overlay.mailWindow = openDialog(url, tId, "chrome,dialog=no,height=400,width=700,resizable,centerscreen");
    } else {
      var gBrowser = simplemail.getBrowser();
      if (content.location != "about:blank") 
        gBrowser.selectedTab = gBrowser.addTab(url)
      else
        content.location.assign(url);
    }
  },

  pub.openedWindows = [],

  pub.refreshTab = function(url) { 
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);  
    var browserEnumerator = wm.getEnumerator("navigator:browser");  

    var found = false;  
    while (!found && browserEnumerator.hasMoreElements()) {  
      var browserWin = browserEnumerator.getNext();  
      var tabbrowser = browserWin.gBrowser;  

      var numTabs = tabbrowser.browsers.length;  
      for (var index = 0; index < numTabs; index++) {  
        var currentBrowser = tabbrowser.getBrowserAtIndex(index);  
        if (url == currentBrowser.currentURI.spec) {  
          tabbrowser.selectedTab = tabbrowser.tabContainer.childNodes[index];  
          browserWin.focus();

          if (simplemail.overlay.openedWindows.length > 0) {
            var openedWin = simplemail.overlay.openedWindows;
            tabbrowser.reload();
            simplemail.overlay.openedWindows = openedWin;
          } else
            tabbrowser.reload();

          found = true;  
          break;  
        }  
      }  
    }

    if (!found) {  
      var recentWindow = wm.getMostRecentWindow("navigator:browser");  
      if (recentWindow)
        recentWindow.delayedOpenTab(url, null, null, null, null)
      else
        window.open(url); 
    }
    //console.error("SM.overlay_refreshTab", found);//userok_log
  },

  pub.testTabUrl = function(url) { 
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var recentWindow = wm.getMostRecentWindow("navigator:browser");
    var actualWindow = recentWindow.getBrowser();

    if (actualWindow.currentURI.spec == url) 
      return true;
  },

  pub.populateMenu = function(menupopup) {
    //console.error("SM.Overlay_populateMenu", this, menupopup);//userok_log
    var taccounts = simplemail.overlay.storage.getAccounts();
    if (!taccounts.length) 
      return false;

    simplemail.clearElement(menupopup);

    for (var i in taccounts) {
      var account = taccounts[i];
      if (!account.pop3.host) 
        continue;

      var menuitem = document.createElement("menuitem");
      menuitem.setAttribute("id", account.id);
      menuitem.setAttribute("label", account);
      menuitem.setAttribute("class", "menuitem-iconic");
      menuitem.setAttribute("image", simplemail.SimpleMailFile.getEnvelopeIconURL(account.color));
      menuitem.addEventListener("click", simplemail.overlay.onMenuClick); // userok
      menuitem.setAttribute("disabled", !simplemail.overlay.timeouts[account.id]);
      menupopup.appendChild(menuitem);
    }
  },

  pub.onMenuClick = function(event) {
    //console.error("SM.Overlay_onMenuClick", event, this);//userok
    var accountId = event.target.id;
    switch (event.button) {
      case 0:
        simplemail.overlay.getMail(accountId);
        for (var element = event.target; element; element = element.parentNode) {
          if (element.nodeName == "menupopup") 
            element.hidePopup();
        }
        break;
      case 2:
        clearTimeout(simplemail.overlay.timeouts[accountId]);
        delete simplemail.overlay.timeouts[accountId];
        break;
    }
    event.target.setAttribute("disabled", !simplemail.overlay.timeouts[accountId]);
  },

  pub.onContentMenuShowing = function(event) {
    var taccounts = simplemail.overlay.storage.getAccounts();
    
    if (event.target.id == "contentAreaContextMenu")
      simplemail.domGet("SimpleMail-content-send-menu").hidden = !taccounts.length
    else if (event.target.id == "SimpleMail-content-send-menu")
      simplemail.overlay.populateFavoriteMenu(event.target);
  },

  // userok: rewrited
  pub.populateFavoriteMenu = function(menupopup) {
    simplemail.clearElement(menupopup);
    
    var haveFav;    
    var taddresses = simplemail.overlay.storage.getAddresses();
    for (var i in taddresses) {
      if (taddresses[i].favorite) {
        var menuitem = document.createElement("menuitem");
        menuitem.setAttribute("label", taddresses[i].name || taddresses[i]);
        var fav = taddresses[i].toString();
        menuitem.addEventListener("command",
                                    function(fav) {
                                        return function() { simplemail.overlay.openSendContent(fav); }
                                    }(fav), false);
        menupopup.appendChild(menuitem);
        haveFav = true;
      }
    }
    
    if (haveFav)
      menupopup.appendChild(document.createElement("menuseparator"));
    
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", simplemail.Bundle.getString("new"));
    menuitem.addEventListener("command", function(){simplemail.overlay.openSendContent();}, false); 
    menupopup.appendChild(menuitem);
  },

  pub.openSendContent = function(address) {
    var tmessage  = new simplemail.Message();
    tmessage.to   = address;
    tmessage.html = simplemail.overlay.getContent(gContextMenu.target);
    if (simplemail.SimpleMailPrefs.getBool("plaintextOnSend"))
      tmessage.html = simplemail.SimpleMailText.linkToText(tmessage.html);

    simplemail.overlay.openNewMessage(tmessage);
  },

  pub.getContent = function(element) {
    function link(url, title) {
      return simplemail.SimpleMailFile.isLocalURL(url) ? ""
              : "<a href='" + url + "'>" + (title || url) + "</a>";
    }
    
    var doc  = element.ownerDocument;
    var html = simplemail.SimpleMailText.getSelectedHtml(doc);

    if (!html && element.value) { // INPUT & TEXTAREA
      var length = element.selectionEnd - element.selectionStart;
      html = element.value.substr(element.selectionStart, length);
    }
    if (!html && element.nodeName == "IMG")
      html = "<img src='" + element.src + "'>";

    if (html) {
      var link = link(doc.location, doc.title);
      if (link) 
        html += "<br><br>" + simplemail.Bundle.getString("infoSource", [link]);
      return html;
    } else if (element.nodeName == "A") {
      return link(element.href, element.innerHTML);
    } else 
      return link(doc.location, doc.title);
  },

  pub.errors    = 0,
  pub.instances = [], // Running GetMail, deleteMail, SendMail instances

  pub.error = function(messageId, params) {
    simplemail.overlay.errors++;
    simplemail.error(messageId, params);
  },
  
  // userok: async
  pub.getStatus = function(callbackDone) {
    simplemail.overlay.storage.getUnreadCount(function(tUnreadCount) { 
      var tstatus = simplemail.overlay.instances.length ? "loading" :
           simplemail.overlay.errors ? "errors" :
           tUnreadCount ? "mail" : simplemail.overlay.lastCheckTime ? "noMail" : "notChecked";
      if (callbackDone)
        callbackDone(tstatus, tUnreadCount);
    });
  },
  
  // userok: async
  pub.updateIcons = function() {
    //console.error("SM.overlay_updateIcons", this);//userok_log
    simplemail.overlay.getStatus(function(tstatus, tUnreadCount) {
      //console.error("SM.overlay_updateIconsCallback", tstatus, tUnreadCount);//userok_log
      
      simplemail.domGet("SimpleMailStatusBar-unreadCount").value = tUnreadCount;

      simplemail.domGet("SimpleMail-status").hidden =
         ((tstatus == "noMail" || tstatus == "loading" || tstatus == "notChecked" ) && simplemail.SimpleMailPrefs.getBool("hideStatusNoMail"))
         || simplemail.SimpleMailPrefs.getBool("hideAll");

      simplemail.domGet("SimpleMailStatusBar-unreadCount").hidden =
          ((tstatus == "noMail" || tstatus == "loading" || tstatus == "notChecked" ) && simplemail.SimpleMailPrefs.getBool("hideNoMail"))
          || simplemail.SimpleMailPrefs.getBool("hideAll");

      simplemail.domGet("SimpleMail-icon").setAttribute("SimpleMail-status", tstatus);      
      
      var toolbarButton = simplemail.domGet("SimpleMail-toolbarbutton");
      if (toolbarButton) {
        simplemail.domGet("SimpleMailToolbar-unreadCount").value = tUnreadCount;
        simplemail.domGet("SimpleMailToolbar-unreadCount").hidden = 
          (tstatus == "noMail" || tstatus == "loading" || tstatus == "notChecked" ) && simplemail.SimpleMailPrefs.getBool("hideNoMail");

        toolbarButton.setAttribute("SimpleMail-status", tstatus);
        simplemail.domGet("SimpleMailToolbar-unreadCount").setAttribute("SimpleMail-status", tstatus);
        simplemail.domGet("SimpleMailStatusBar-unreadCount").setAttribute("SimpleMail-status", tstatus);
        simplemail.domGet("SimpleMailToolbar-icon").setAttribute("SimpleMail-status", tstatus);   
      }

      // userok: updateFavIcon
      var mainWindow = simplemail.overlay.getMainWindow(true);
      if (mainWindow)
        mainWindow.SimpleMail_updateFavIcon();
      
      if (!simplemail.overlay.instances.length)
        simplemail.overlay.errors = 0;      
    });
  },

  pub.updateTooltip = function() {
    var status     = simplemail.domGet("SimpleMail-icon").getAttribute("SimpleMail-status");
    var timePassed = simplemail.SimpleMailDate.timePassed(simplemail.overlay.lastCheckTime);
		// userok
		var smtooltip  = simplemail.Bundle.getString(status) + (timePassed ? " (" + timePassed + ")" : ""); 
		simplemail.domGet("SimpleMail-tooltip").label = smtooltip;
		// userok
		var toolbarButton = simplemail.domGet("SimpleMail-toolbarbutton");
    if (toolbarButton) 
			toolbarButton.setAttribute("tooltiptext", smtooltip);
  },

  pub.lastCheckTime = null,
  pub.timeouts      = [], // Holds timeouts for each account
  
  pub.InstanceListener = function() {
    var _this = this;
    this._instance;

    this.__defineSetter__("instance", function(instance) {
      _this._instance = instance;
      simplemail.overlay.instances.push(instance);
    });

    this.cleanUp = function() {
      for (var i = 0; i < simplemail.overlay.instances.length; i++) {
        if (simplemail.overlay.instances[i] == _this._instance)
          simplemail.overlay.instances.splice(i, 1);
      }
      simplemail.overlay.updateIcons();
    };
    
    this.onFinish = function(error) {
      simplemail.overlay.errors |= error;
      _this.cleanUp();
    }
  },

  // Add to database
  pub.addMessage = function(message) {
    simplemail.overlay.storage.saveMessage(message);
    var mainWindow = simplemail.overlay.getMainWindow(true);
    if (mainWindow)
      mainWindow.simplemail.messageTreeView.onMessageAdded(message);
    else
      simplemail.overlay.updateIcons();
  },

  pub.newMessagesCount = 0,
  pub.finish           = null,

  pub.GetMailListener = function(account) {
    //this.acc = account;//userok_log
    //console.error("SM.GetMailListener", this);//userok_log

    //var se/lf = this; // userok replace_self_this
    this.inheritFrom = simplemail.overlay.InstanceListener;
    this.inheritFrom();
          
    this.existOnServer = [];

    this.messageExists = function(accountId, uid) {
      this.existOnServer[uid] = uid; // userok: replace_self_this
      return simplemail.overlay.storage.messageExists(accountId, uid);
    }

    this.onMessage = function(message, mailInterface) {
      var LMessage      = message; // userok fix warning
      LMessage.folderId = simplemail.Folder.INBOX;
      var filterManager = new simplemail.FilterManager(simplemail.overlay.storage, mailInterface);
      LMessage = filterManager.execute(LMessage, simplemail.Filter.INBOX);
      
      if (LMessage) {
        if (LMessage.folderId != simplemail.Folder.TRASH) {
          simplemail.overlay.newMessagesCount++;

          if (simplemail.SimpleMailPrefs.getString("popupNotification") == "onEveryMessage") {
            popup(LMessage.subject, LMessage.from, LMessage.spam);
          }
        }
        simplemail.overlay.addMessage(LMessage);
  
        if(simplemail.SimpleMailPrefs.getBool("mailSound")){
          var param = simplemail.SimpleMailPrefs.getString("mailSoundPath");
          simplemail.SimpleMailSound.play(param);
        }
        
        if (simplemail.SimpleMailPrefs.getString('forwardParam') !== null) {
          var tfilters = simplemail.overlay.storage.getFilters();      
          for (var i = 0; LMessage && i < tfilters.length; i++) { 
            var filter = tfilters[i];
            for (var j in filter.rules) {
              if (filter.rules[j].param) {
                for (var k in filter.actions) {
                  var action = filter.actions[k];
                  if (!LMessage.fwd && LMessage.uid && !LMessage.partial && action.name == "forward") {
                    simplemail.messageTreeView.autoForward(LMessage);
                  }
                }
              }
            }     
          }
        }
      }
    }

    function synchronizeIMAP(iself) {
      var messages = simplemail.overlay.storage.getAccountMessages(account.id);
      var deleted  = [];
      for (var i in messages) {
        var message = messages[i];
        if (message.uid && !iself.existOnServer[message.uid]) { // userok: replace_self_this
          message.uid = "";
          deleted.push(message);
        }
      }
      simplemail.overlay.dodeleteMessages(deleted);
    }

    function popup(text, title, messageType) {
      if (messageType) {
        messageType = "Spam";
        title = "SPAM - " + title;
      }
      simplemail.SimpleMailPopup.open("chrome://simplemail/skin/status/mail_large.png", title, text, simplemail.overlay.open, messageType);
    }

    this.onFinish = function(error) {
      //console.error("SM.onFinish", (this == se/lf), this);//userok_log
      if (!error && account.pop3.isImap)
        synchronizeIMAP(this); // userok: replace_self_this

      simplemail.overlay.errors |= error;
      this.cleanUp(); // userok: replace_self_this

      for(var i = 0; i < simplemail.overlay.instances.length; i++) {
        if (simplemail.overlay.instances[i] instanceof simplemail.SimpleMailSocks.SimpleMailGetMail){
        simplemail.overlay.finish = account;
        return;
        }
      }
      if (simplemail.overlay.newMessagesCount && simplemail.SimpleMailPrefs.getString("popupNotification") == "summary") {
        var text = simplemail.Bundle.getString("newMessages", [simplemail.overlay.newMessagesCount]);
        popup(text, "Simple Mail");
      }
      simplemail.overlay.newMessagesCount = 0;
    }
    simplemail.SimpleMailPrefs.clear('forwardParam'); // Clean up temporary prefs
  },

  pub.getMail = function(accountId) {
    simplemail.overlay.lastCheckTime = new Date();
    var taccounts = simplemail.overlay.storage.getAccounts();
    for (var i = 0, j = taccounts.length; i < j; i++) {
      var account = taccounts[i];
        
      if (!account.pop3.host || (accountId && account.id != accountId)) 
        continue;
      if (!accountId && account.refresh < 0) 
        continue;

      simplemail.SimpleMailCheck.open(account);

      clearTimeout(simplemail.overlay.timeouts[account.id]);
      if (account.refresh > 0) {
        // userok
        simplemail.overlay.timeouts[account.id] =
          setTimeout(function(accId) {
            //console.error("SM.getMail.accId: ", accId);//userok
            simplemail.overlay.getMail(accId);
          }, account.refresh * 60 * 1000, account.id);
      }
        
//userok: turn off test      if (account.pop3.isImap) {
//userok: turn off test        var messages = simplemail.overlay.storage.getAccountMessages(account.id);
//userok: turn off test        simplemail.overlay.SynchroMail(account, messages, "inbox", "");
//userok: turn off test      }
      simplemail.overlay.updateIcons();
    }
  },

  pub.groupByAccounts = function(messages) {
    var grouped = [];
    for (var i in messages) {
      var message = messages[i];
      if (!grouped[message.accountId])
        grouped[message.accountId] = [];

      grouped[message.accountId][message.id] = message;
    }
    return grouped;
  },

  // userok: rewrited, async (Delete from database)
  pub.dodeleteMessages = function(aMessages) {
    simplemail.overlay.storage.deleteMessages(function(amsgs) {
      var mainWindow = simplemail.overlay.getMainWindow(true);
      if (mainWindow)
        mainWindow.simplemail.messageTreeView.onMessagesDeleted(aMessages)
      else
        simplemail.overlay.updateIcons();      
    }, aMessages);
  },

  pub.askDeleteMail = function(messages, confirmText, wnd, onDelete) {
    function confirmDelete(confirmText, server) {
      if (simplemail.SimpleMailPrefs.getBool("confirmdelete")) {
        var check  = { value: simplemail.SimpleMailPrefs.getBool("deleteFromServer") };
        var result = !server ? simplemail.confirm(confirmText, wnd)
                             : simplemail.confirmCheck(confirmText, simplemail.Bundle.getString("deleteFromServer"), check, wnd);
        
        if (result) 
          simplemail.SimpleMailPrefs.setBool("deleteFromServer", check.value);
        
        return { delete: result, server: check.value };
      } else
        return { delete: true, server: true };
    }
    
    var grouped = [];
    for (var i in messages) {
      var message = messages[i];
      var deleteMode = simplemail.Account.NEVER;
      if (message.uid) {
        var account = simplemail.overlay.storage.getAccount(message.accountId);
        if (account) 
          deleteMode = account.deleteMode;
      }
      
      if (deleteMode == simplemail.Account.ON_RECEIVE)
        deleteMode = message.partial ? simplemail.Account.ASK : simplemail.Account.NEVER;

      if (!grouped[deleteMode]) 
        grouped[deleteMode] = [];
      grouped[deleteMode].push(message);
    }

    var confirm = confirmDelete(confirmText, grouped[simplemail.Account.ASK]);
    if (!confirm.delete) 
      return;

    var deleteMode = confirm.server ? simplemail.Account.ALWAYS : simplemail.Account.NEVER;
    grouped[deleteMode] = (grouped[deleteMode] || []).concat(grouped[simplemail.Account.ASK] || []);

    simplemail.overlay.dodeleteMessages(grouped[simplemail.Account.NEVER]);
    simplemail.overlay.deleteMail(grouped[simplemail.Account.ALWAYS], onDelete);
  },

  pub.DeleteMailListener = function(onDelete) {
    var _this = this;
    this.inheritFrom = simplemail.overlay.InstanceListener;
    this.inheritFrom();

    this.onFinish = function(error, deleted) {
      simplemail.overlay.dodeleteMessages(deleted);
      if (onDelete) 
        onDelete();

      simplemail.overlay.errors |= error;
      _this.cleanUp();
    }
  },

  pub.deleteMail = function(messages, onDelete) {
    if (!messages || !messages.length) {
      if (onDelete) 
        onDelete();
      return;
    }
    
    messages = simplemail.overlay.groupByAccounts(messages);
    for (var accountId in messages) {
      var account = simplemail.overlay.storage.getAccount(accountId);
      if (!account) 
        simplemail.overlay.error("accountNoLongerExist");
      else {
        var listener      = new simplemail.overlay.DeleteMailListener(onDelete);
        listener.instance = new simplemail.SimpleMailSocks.SimpleMailDeleteMail(account, listener, messages[accountId]).execute();
      }
    }
    
    simplemail.overlay.updateIcons();
  },

  pub.SendMailListener = function(message, onSend) {
    var kself = this;
    this.inheritFrom = simplemail.overlay.InstanceListener;
    this.inheritFrom();

    this.onFinish = function(error) {
      if (!error) {
        message.folderId = simplemail.Folder.SENT;
        message.read = true;
        var account  = simplemail.overlay.storage.getAccount(message.accountId);

        var filterManager = new simplemail.FilterManager(simplemail.overlay.storage, {
          getBody: function(msg) {},
          delete:  function(msg) {
            simplemail.overlay.dodeleteMessages([msg]);
          }
        });

//userok: turn off test        if (account.pop3.isImap) {
//userok: turn off test          var folder   = "sent";
//userok: turn off test          var messages = [];       
//userok: turn off test          messages.push(message);
//userok: turn off test          simplemail.overlay.SynchroMail(account, messages, folder, "");
//userok: turn off test        }

        if (simplemail.SimpleMailPrefs.getBool("addressBookAddOnSend")) {
          var recipients = message.to + "," + message.cc + "," + message.bcc;
          // userok: async
          simplemail.overlay.storage.addAddressList(function(taddr) {
            //console.error("SM.zzz", this, simplemail, simplemail.addressTreeView);//userok_log
            //simplemail.addressTreeView.treebox.rowCountChanged(simplemail.addressTreeView.rowCount - 1, 1);//TypeError: simplemail.addressTreeView is undefined
          }, recipients);
        }
        
        if (message && simplemail.SimpleMailPrefs.getString('forwardParam')) {
          message = filterManager.execute(message, simplemail.Filter.SENT);
          simplemail.overlay.storage.saveMessage(message);
        }
        
        if (message && simplemail.SimpleMailPrefs.getString('forwardParam') == null) {
          message = filterManager.execute(message, simplemail.Filter.SENT); 
          message.to = simplemail.SimpleMailPrefs.getString('originalTo');
          message.cc = simplemail.SimpleMailPrefs.getString('originalCc');
          message.bcc = simplemail.SimpleMailPrefs.getString('originalBcc');
          simplemail.overlay.addMessage(message);
                         
          if (message.subject.match(/^(Re:)/i)){
            var originalId = simplemail.SimpleMailPrefs.getString('originalId');
            var messageOri = simplemail.overlay.storage.getMessage(originalId);
            if (typeof(messageOri) == 'undefined')
              var messageOri = message;
            messageOri.replied = true;
            simplemail.overlay.storage.saveMessageState(messageOri);
//userok: turn off test            if (messageOri.replied) {
//userok: turn off test              var account  = simplemail.overlay.storage.getAccount(messageOri.accountId);
//userok: turn off test              var messages = [];
//userok: turn off test              messages.push(messageOri);
//userok: turn off test              simplemail.overlay.SynchroMail(account, messages, folder, "Answered");
//userok: turn off test            }
          }
          if (message.subject.match(/^(Fwd:)/i)){
            var originalId = simplemail.SimpleMailPrefs.getString('originalId');
            var messageOri = simplemail.overlay.storage.getMessage(originalId);
            if (typeof(messageOri) == 'undefined')
              var messageOri = message;
            messageOri.fwd = true;
            simplemail.overlay.storage.saveMessageState(messageOri);
          }
          simplemail.SimpleMailPrefs.clear('forwardParam'); // Clean up temporary prefs
        }

        if (onSend) {
          onSend();
          var textsent = message.subject + " - " + simplemail.Bundle.getString("messagesent");
          var account = simplemail.overlay.storage.getAccount(message.accountId);
          simplemail.SimpleMailPopup.open("chrome://simplemail/skin/status/mail_large.png", "Simple Mail - " + account, textsent);
        }
      }

      simplemail.overlay.errors |= error;
      kself.cleanUp();

      simplemail.SimpleMailPrefs.clear('originalId');
      simplemail.SimpleMailPrefs.clear('originalTo');
      simplemail.SimpleMailPrefs.clear('originalCc');
      simplemail.SimpleMailPrefs.clear('originalBcc');
    }
  },
  
  pub.autosendMail = function(message, onSend) { 
    var account = simplemail.overlay.storage.getAccount(message.accountId);
    if (!account) 
      simplemail.overlay.error("accountNoLongerExist");
    else {
      var listener      = new simplemail.overlay.SendMailListener(message, onSend);
      listener.instance = new simplemail.SimpleMailSocks.SimpleMailSendMail(account, listener, message).execute();
    }
    simplemail.overlay.updateIcons();
  },
      
  pub.sendMail = function(message, onSend) {
    var account = simplemail.overlay.storage.getAccount(message.accountId);
    simplemail.SimpleMailPrefs.setString('accountError', account.name);
    if (!account) 
      simplemail.overlay.error("accountNoLongerExist");
    else {
      var listener      = new simplemail.overlay.SendMailListener(message, onSend);
      listener.instance = new simplemail.SimpleMailSocks.SimpleMailSendMail(account, listener, message).execute();
      
      var gBrowser = simplemail.getBrowser();
      for (var i = 0; i < gBrowser.browsers.length; i++) {
        var browser = gBrowser.browsers[i];
        var uri = browser.currentURI.spec.replace(/(\?).*?/ig, "");
        var uri = uri.replace(/([0-9]).*?/ig, "");
        if (uri == "chrome://simplemail/content/newmessage.xul")
          simplemail.overlay.mailTab = browser.contentWindow.wrappedJSObject;
      }
      
      // userok
      function getWin() { 
        var awin = simplemail.overlay.mailTab;
        if (typeof(awin) == 'undefined')
          var awin = simplemail.overlay.mailWindow;
        if (awin == null)
          var awin = browser.contentWindow.wrappedJSObject; 
          
        return awin;
      }
      
      function cancelSend () {
        var win = getWin(); // userok
        win.document.getElementById("cancelsend").value = "cancelsend";
      }

      // userok: rewrited
      function setProgress(aCounter) {
        var win           = getWin(); 
        var progressMeter = win.document.getElementById("progressMeter");
        if (progressMeter)
          progressMeter.value = aCounter;
      }
      
      function endSend() {
        var win = getWin(); // userok
        clearTimeout(timeoutID);
        if (win !== null) {
          win.document.getElementById("cancelsend").removeEventListener('click', cancelSend, false);
          win.document.getElementById("cancelsend").value         = "";
          win.document.getElementById("cancelsend").hidden        = true;
          win.document.getElementById("progressMeter").collapsed  = true;
          win.document.getElementById("progressMeterText").value  = "";
          win.document.getElementById("progressMeterText").hidden = true;
        }
      }

      function timeout(counter) {
        var win = getWin(); // userok
        var buttoncancelsend = win.document.getElementById("cancelsend");
        buttoncancelsend.addEventListener('click', cancelSend, false);
        //var stat = simplemail.overlay.get/Status();               // userok  
        //if (stat !== "loading" || buttoncancelsend.value == "cancelsend") { // userok
        if (!simplemail.overlay.instances.length || buttoncancelsend.value == "cancelsend") {   // userok
          if (buttoncancelsend.value == "cancelsend") {
            simplemail.overlay.stop();
            endSend();
          } else
            endSend();
        } else {
          counter = counter+5;
          if (counter == 100)
            counter = 0;
          
          setProgress(counter);
          var timeoutID = setTimeout(function() { 
            timeout(counter);
          }, 100);
        }
      }

      var counter = 10;
      setProgress(counter);
      var timeoutID = setTimeout(function() { 
        timeout(counter);
      }, 100);

      var win = getWin();
      win.document.getElementById("cancelsend").hidden        = false;
      win.document.getElementById("progressMeter").collapsed  = false;
      win.document.getElementById("progressMeterText").hidden = false;
      win.document.getElementById("progressMeterText").value  = account.name;
    }
    
    simplemail.overlay.updateIcons();
  },

  pub.GetMailBodyListener = function(messages) {
    // userok: what for? var se/lf = this;
    this.inheritFrom = simplemail.overlay.InstanceListener;
    this.inheritFrom();

    this.onMessage = function(message) {
      var LMessage = message; // userok fix warning
      var old      = messages[LMessage.id];
      simplemail.SimpleMailFile.deleteAttachments(old.attachmentsDir);
      LMessage = simplemail.merge(old, LMessage);

      simplemail.overlay.storage.saveMessage(LMessage);
      var mainWindow = simplemail.overlay.getMainWindow(true);
      if (mainWindow) 
        mainWindow.simplemail.messageTreeView.onMessageUpdated(LMessage);
    }
  },

  pub.getMailBody = function(messages) {
    messages = simplemail.overlay.groupByAccounts(messages);
    for (var accountId in messages) {
      var account = simplemail.overlay.storage.getAccount(accountId);
      if (!account) 
        simplemail.overlay.error("accountNoLongerExist");
      else {
        var listener = new simplemail.overlay.GetMailBodyListener(messages[accountId]);
        listener.instance = new simplemail.SimpleMailSocks.SimpleMailGetMailBody(account, listener, messages[accountId]).execute();
      }
    }
    simplemail.overlay.updateIcons();
  },

  pub.SynchroMailListener = function(account, messages, folder, flag) {
    var _this = this;
    this.inheritFrom = simplemail.overlay.InstanceListener;
    this.inheritFrom();

    this.existOnServer = [];

    this.messageExists = function(accountId, uid) {
      _this.existOnServer[uid] = uid;
      return simplemail.overlay.storage.messageExists(accountId, uid);
    }
    
    this.onMessage = function(message) {
    }
    
    this.onFinish = function(error) {
      simplemail.overlay.errors |= error;
      _this.cleanUp();
    }
  },

  pub.SynchroMail = function(account, messages, folder, flag) {
    if (typeof(account) !== 'undefined') {
      if (account.pop3.isImap) {
        var listener      = new simplemail.overlay.SynchroMailListener(account, messages, folder, flag);
        listener.instance = new simplemail.SimpleMailSocks.SimpleMailSynchroMail(account, listener, messages, folder, flag).execute();
      }
      simplemail.overlay.updateIcons();
    }
  }
  
  return pub;
}();

// userok: start
//console.error("SM.overlay", this);//userok_log
addEventListener("load", simplemail.overlay.preinitialize, false);

simplemail.SimpleMailCheck = function () {
  var pub = {};
  
  pub.queue      = [],
  pub.inProgress = false,
  pub.timeoutID  = [],

  pub.setProgress = function(counter) {
   var win = simplemail.overlay.getMainWindow();
   var progressMeter = win.document.getElementById("progressMeter");
   progressMeter.value = counter;
  }, 

  pub.cancelCheck = function(event) {
    var win = simplemail.overlay.getMainWindow();
    win.document.getElementById("cancelcheck").value = "cancelcheck";
  },

  pub.open = function(accountItem) {
    simplemail.SimpleMailCheck.queue.push({ accountItem: accountItem });
    simplemail.SimpleMailCheck.showNext();
  },

  pub.showNext = function() {
    if (simplemail.SimpleMailCheck.inProgress) 
      return;
    
    var item = simplemail.SimpleMailCheck.queue.shift();
    if (!item) 
      return;

    simplemail.SimpleMailPrefs.setString('accountError', item.accountItem);

    var listener      = new simplemail.overlay.GetMailListener(item.accountItem);
    listener.instance = new simplemail.SimpleMailSocks.SimpleMailGetMail(item.accountItem, listener, simplemail.SimpleMailPrefs.getBool("headersOnly")).execute();
    
    simplemail.SimpleMailCheck.inProgress = true;

    var actualWindow = simplemail.overlay.testTabUrl("chrome://simplemail/content/main/main.xul");
    if (actualWindow) {
      var win = simplemail.overlay.getMainWindow();
      win.document.getElementById("progressMeter").collapsed  = false; 
      win.document.getElementById("cancelcheck").hidden       = false;
      win.document.getElementById("progressMeterText").hidden = false;
      win.document.getElementById("progressMeterText").value  = item.accountItem;
      var counter = 10;
    }
    simplemail.overlay.updateIcons();
    simplemail.SimpleMailCheck.show(item, counter);
  },

  pub.show = function(item, counter) {
    var actualWindow = simplemail.overlay.testTabUrl("chrome://simplemail/content/main/main.xul");
    
    if (actualWindow) {
      var win = simplemail.overlay.getMainWindow();
      win.document.getElementById("cancelcheck").addEventListener('click', simplemail.SimpleMailCheck.cancelCheck, false);
      simplemail.SimpleMailCheck.setProgress(counter);
  
      win.document.getElementById("progressMeterText").value = item.accountItem;
                   
      if (win.document.getElementById("cancelcheck").value == "cancelcheck") {
        simplemail.overlay.stop();
        setTimeout(function() {
          endCheck();
        }, 10);
      }
    }
    
    //var stat = simplemail.overlay.get/Status(); // userok
    //if (stat !== "loading") {                   // userok
    if (!simplemail.overlay.instances.length) {   // userok
      setTimeout(function() {
        endCheck();
      }, 10);
    }

    if (simplemail.overlay.finish == item.accountItem) {
      simplemail.SimpleMailCheck.inProgress = false;
      simplemail.SimpleMailCheck.showNext();
    }

    counter = counter + 5;
    if (counter == 105)
      counter = 0;

    simplemail.SimpleMailCheck.timeoutID[item] = setTimeout(function() {
        simplemail.SimpleMailCheck.show(item,counter);
      }, 100);

    function endCheck() {
      clearTimeout(simplemail.SimpleMailCheck.timeoutID[item]);
      if (actualWindow) {
        win.document.getElementById("cancelcheck").value        = "";
        win.document.getElementById("cancelcheck").hidden       = true;
        win.document.getElementById("progressMeter").collapsed  = true;
        win.document.getElementById("progressMeterText").value  = "";
        win.document.getElementById("progressMeterText").hidden = true;
        win.document.getElementById("cancelcheck").removeEventListener('click', simplemail.SimpleMailCheck.cancelCheck, false); 
      }
      
      simplemail.SimpleMailCheck.inProgress = false;
      simplemail.SimpleMailPrefs.clear('accountError');
      simplemail.SimpleMailCheck.showNext();
    }
  }
  
  return pub;
}();