// userok: rewrited_module
var dirLocation = simplemail.SimpleMailFile.getExtensionDirectory(); // Pre-load due to asynchronous callback in AddonManager

function EditAccount_Initialize() {
  var account    = window.arguments[0].inn.account;
  document.title = (account.id) ? simplemail.Bundle.getString("editAccount", [account])
                                : simplemail.Bundle.getString("newAccount");
  // getValues
  //console.error("SM.EditAccount_Initialize", account);//userok_log
  simplemail.domGet("name").value      = account.name;
  simplemail.domGet("email").value     = account.email;
  simplemail.domGet("password").value  = account.pop3.getPassword();
  simplemail.domGet("replyTo").value   = account.replyTo;
  simplemail.domGet("refresh").value   = account.refresh;
  simplemail.domGet("subject").value   = account.subject;
  simplemail.domGet("signature").value = account.signature;
  simplemail.selectItem("deleteMode", account.deleteMode);
  EditAccount_setColor("color", account.color || "00.png");
  
  simplemail.domGet("pop3host").value          = account.pop3.host;
  simplemail.domGet("pop3port").value          = account.pop3.port;
  simplemail.domGet("pop3login").value         = account.pop3.login;
  simplemail.domGet("inProt").selectedIndex    = account.pop3.isImap || 0;
  simplemail.domGet("pop3auth").selectedIndex  = account.pop3.auth || 0;
  simplemail.domGet("onreceive").disabled      = (simplemail.domGet("inProt").selectedIndex) ? true : false;
  simplemail.domGet("pop3ssl").selectedIndex   = (account.pop3.ssl) ? 1: 0;

  simplemail.domGet("smtpHost").value          = account.smtp.host;
  simplemail.domGet("smtpPort").value          = account.smtp.port;
  simplemail.domGet("smtpLogin").value         = account.smtp.login;
  simplemail.domGet("smtpAuth").selectedIndex  = (account.smtp.auth) ? 1: 0;
  var smtpSsl = simplemail.domGet("smtpSsl");
  if (account.smtp.ssl)
    smtpSsl.selectedIndex = 1;
  else if (account.smtp.tls)
    smtpSsl.selectedIndex = 2;
  else
    smtpSsl.selectedIndex = 0;
}

function EditAccount_CheckEmail(account) {
	var tabMain      = simplemail.domGet('tabMain');
  var email        = simplemail.domGet('email');
  var accountEmail = account.email;
	if (accountEmail)
		accountEmail = accountEmail.toLowerCase();
  // duplicated account
	simplemail.overlay = simplemail.getBrowserWindow().simplemail.overlay;
	var taccounts      = simplemail.overlay.storage.getAccounts();
	for (var i in taccounts) {
		if (taccounts[i].email.toLowerCase() == email.value.toLowerCase() && email.value.toLowerCase() !== accountEmail) {
			simplemail.alert(simplemail.Bundle.getString('accountAlert'));
			account.email = accountEmail;
			email.value   = accountEmail;
      EditAccount_OnChange(email, null);
      setTimeout(function(eml, tbMain) {
        tbMain.selectedIndex = 0;
				eml.focus();
			}, 10, email, tabMain);
			return false;
		}
	}
  // wrong address
	if (!email.value.toLowerCase().match(/^[a-z0-9._%+-]+@(?:[a-z0-9-])/gim)) {
		simplemail.alert(simplemail.Bundle.getString('addressAlert'));
		if (accountEmail) {
			account.email = accountEmail;
			email.value   = accountEmail;
		} else {
			account.email = null;
			email.value   = 'test@localhost';
		}
    EditAccount_OnChange(email, null);
    setTimeout(function(eml, tbMain) {
			tbMain.selectedIndex = 0;
      eml.focus();
		}, 10, email, tabMain);
		return false;
	}
	return true;
}

function EditAccount_populateEnv(id) {
  var ICONS_PER_ROW = 5;
  var dirLocation   = simplemail.SimpleMailFile.getEnvDirectory();     

  var hbox, i = 0;
  var menupopup = simplemail.domGet(id).firstChild;
  simplemail.clearElement(menupopup);

  simplemail.SimpleMailFile.forEachFile(dirLocation, function(file) {
    var image = document.createElement("image");
    image.setAttribute("src", simplemail.SimpleMailFile.getEnvelopeIconURL(file.leafName));
    image.value = file.leafName;

    if (i++ % ICONS_PER_ROW == 0) {
      hbox = document.createElement("hbox");
      menupopup.appendChild(hbox);
    }
    hbox.appendChild(image);
  });
}

function EditAccount_setColor(id, value) {
  //console.error("SM.EditAccount_setColor", id, value);//userok_log
  if (!value) 
    return;

  var color = simplemail.domGet(id);
  if (color) {
    color.image = simplemail.SimpleMailFile.getEnvelopeIconURL(value);
    color.value = value;
    color.firstChild.hidePopup();
  }
}

function EditAccount_Autoconfig() {
  // parse
  var aMail   = simplemail.domGet('email').value;
  var arrMail = aMail.split('@');
  if (!arrMail || arrMail.length != 2)
    return;
  // check domain
  var domain = arrMail[1];
  if (!domain)
    return;
  // find
  //console.error('SM.EditAccount_Autoconfig', aMail, aAddress, domain);//userok_log
  var inProt = simplemail.domGet('inProt');
  var aBase  = getAutoConfigBase();
  for (var i in aBase) {
    var cfg = aBase[i];
    if (cfg.d.indexOf(domain) != -1) {
      // check avail
      if ((inProt.value == 'imap') && !cfg.imap)
        inProt.selectedIndex = 0;
      if ((inProt.value == 'pop3') && !cfg.pop3)
        inProt.selectedIndex = 1;
      // set
      var inbound = (inProt.value == 'imap') ? cfg.imap : cfg.pop3;
      // inbound
      simplemail.domGet('pop3host').value        = inbound.h;
      simplemail.domGet('pop3port').value        = inbound.p;
      simplemail.domGet('pop3ssl').selectedIndex = (inbound.t == 'ssl') ? 1: 0;
      // outbound
      simplemail.domGet("smtpHost").value        = cfg.smtp.h;
      simplemail.domGet("smtpPort").value        = cfg.smtp.p;
      var smtpSsl = simplemail.domGet('smtpSsl');
      if (cfg.smtp.t == 'ssl')
        smtpSsl.selectedIndex = 1;
      else if (cfg.smtp.t == 'tls')
        smtpSsl.selectedIndex = 2;
      else
        smtpSsl.selectedIndex = 0;
      // delmode
      simplemail.domGet("deleteMode").selectedIndex = (inProt.value == 'imap') ? 0 : 2;
      //console.error("SM.EditAccount_Autoconfig_found", inbound, cfg.smtp, domain, simplemail.domGet("deleteMode"));//userok_log
      return true;
    }
  }
  // not found: defaults
  simplemail.domGet("pop3host").value        = ((inProt.value == 'pop3') ? 'pop.' : 'imap.') + domain;
  simplemail.domGet("pop3port").value        =  (inProt.value == 'pop3') ? '110' : '143';        
  simplemail.domGet("smtpHost").value        = 'smtp.' + domain;
  simplemail.domGet("smtpPort").value        = '25';
  simplemail.domGet("pop3ssl").selectedIndex = 0;
  simplemail.domGet("smtpSsl").selectedIndex = 0;
}
  
function EditAccount_OnChange(self, event) {
  //console.error("SM.EditAccount_OnChange", self, self.value, event);//userok_log
  switch (self.id) {
    case "email":
      simplemail.domGet("pop3login").value = self.value;
      simplemail.domGet("smtpLogin").value = self.value;
      EditAccount_Autoconfig();
      break;
    case "inProt":
      if (self.value == "imap") {
        simplemail.domGet("onreceive").disabled = true;
        simplemail.selectItem("deleteMode", "never");
      } else {
        simplemail.domGet("onreceive").disabled = false;
        simplemail.selectItem("deleteMode", window.arguments[0].inn.account.deleteMode);
      }
      simplemail.domGet("deleteMode").selectedIndex = (self.value == "imap") ? 0 : 2;
      EditAccount_Autoconfig();
      break;
  }
}

function EditAccount_OnAccept() {
  var account = window.arguments[0].inn.account;
	if (!EditAccount_CheckEmail(account))
		return false;

	account.name    = simplemail.domGet("name").value;
	account.email   = simplemail.domGet("email").value;
	account.color   = simplemail.domGet("color").value;
	account.replyTo = simplemail.domGet("replyTo").value;
	account.refresh = simplemail.domGet("refresh").value;
	if (simplemail.domGet("inProt").selectedIndex && account.deleteMode == "onreceive")
		account.deleteMode = "never"
	else
		account.deleteMode = simplemail.domGet("deleteMode").selectedItem.value;

	account.subject         = simplemail.domGet("subject").value;
	account.signature       = simplemail.domGet("signature").value;

	account.pop3.host       = simplemail.domGet("pop3host").value;
	account.pop3.port       = simplemail.domGet("pop3port").value;
	account.pop3.login      = simplemail.domGet("pop3login").value;
	account.pop3.password   = simplemail.domGet("password").value;
	account.pop3.ssl        = (simplemail.domGet("pop3ssl").selectedIndex == 1);
	account.pop3.auth       = simplemail.domGet("pop3auth").selectedIndex;
	account.pop3.isImap     = simplemail.domGet("inProt").selectedIndex;
  
	account.smtp.host       = simplemail.domGet("smtpHost").value;
	account.smtp.port       = simplemail.domGet("smtpPort").value;
	account.smtp.login      = simplemail.domGet("smtpLogin").value;
	account.smtp.password   = simplemail.domGet("password").value;
	account.smtp.ssl        = (simplemail.domGet("smtpSsl").selectedIndex == 1);
	account.smtp.tls        = (simplemail.domGet("smtpSsl").selectedIndex == 2);
	account.smtp.auth       = (simplemail.domGet("smtpAuth").selectedIndex == 1);
	window.arguments[0].out = {account: account};

	return true;
}

function EditAccount_OnCancel() {
  if (simplemail.domGet("inProt").selectedIndex) {
    var account = window.arguments[0].inn.account;
    if (account.deleteMode == "onreceive")
      account.deleteMode = "never";
  }
}
