var actionTree, actions;

function initActions(aActions) {
  actions    = aActions;
  actionTree = simplemail.domGet("action-tree");
  actionTree.view = actionTreeView;
  if (actionTree.view.rowCount > 0) 
    actionTree.view.selection.select(0);
}

var actionTreeView = {
  get rowCount() {
    return actions.length;
  },
  
  getCellText: function(row, column) {
    var name  = column.id.replace(/action-/, "");
    var value = actions[row][name];

    if (name == "param") {
      var action = actions[row]["name"];
      switch (action) {
        case "color": 
          return "██";
        case "folder":
          var folder = simplemail.overlay.storage.getFolder(value) || simplemail.overlay.storage.getFolder(simplemail.Folder.INBOX);
          return folder.getName();
      }
    }
    return simplemail.Bundle.getString(value) || value;
  },
  
  // userok: rewrited
  getCellProperties: function(row, column, props) {
    var name  = column.id.replace(/action-/, "");
    var value = actions[row][name];
    if (name == "param" && actions[row]["name"] == "color") {
      var cval = 'cl' + value.replace('#', '');
      if (props) {
        var atom = actionTreeView.atomService.getAtom(cval);
        props.AppendElement(atom);
      } else 
        return cval;
    }
  },
  
  action: editAction,
  delete: deleteActions
};

simplemail.DefaultTreeView.extend(actionTreeView);

function onSelectAction() {
  simplemail.domGet("action-edit").disabled = 
  simplemail.domGet("action-delete").disabled = !actionTree.view.selection.getRangeCount();
}

// userok: rewrited
function editAction(add) {
  var act   = add ? simplemail.overlay.storage.createAction(null, null, '', '') : actions[actionTree.currentIndex];
  var param = { action: act };
  openDialog("chrome://simplemail/content/preferences/filter/action.xul", "simplemail-preferences-filter-action-window", "chrome,centerscreen,modal,resizable", param);
  if (!param.action) 
    return;

  if (add) {
    actions.push(param.action);
    actionTreeView.treebox.rowCountChanged(actionTreeView.rowCount - 1, 1);
    actionTree.view.selection.select(actionTreeView.rowCount - 1);
  } else {
    actionTreeView.treebox.invalidateRow(actionTree.currentIndex);
  }
}

function deleteActions() {
  if (simplemail.confirm(simplemail.Bundle.getString("deleteAction"))) {
    actionTreeView.forEachSelected(function(index) {
      actions.splice(index, 1);
      actionTreeView.treebox.rowCountChanged(index, -1);
    });
  }
}
