if (typeof(simplemail) == "undefined")
  var simplemail = {a: "rule.js"};

function initRules(aRules, aType) {
  simplemail.rules         = aRules;
  simplemail.ruleType      = aType;
  simplemail.ruleTree      = simplemail.domGet("rule-tree");
  simplemail.ruleTree.view = ruleTreeView;
  if (simplemail.ruleTree.view.rowCount > 0) 
    simplemail.ruleTree.view.selection.select(0);
}

var ruleTreeView = {
  get rowCount() {
    return simplemail.rules.length;
  },
  getCellText: function(row, column) {
    var name  = column.id.replace(/rule-/, "");
    var value = simplemail.rules[row][name];
    switch(name) {
      case "not":
        value = value ? "not" : "";
        break;
      case "param":
        var property = simplemail.rules[row]["property"];
        switch(property) {
          case "size":
            value = simplemail.size2string(value);
            break;
          case "accountId":
            value = simplemail.overlay.storage.getAccount(value);
            break;
        }
        break;
    }
    return simplemail.Bundle.getString(value) || value;
  },
  action: editRule,
  delete: deleteRules
};
simplemail.DefaultTreeView.extend(ruleTreeView);

function onSelectRule() {
  simplemail.domGet("rule-edit").disabled =
  simplemail.domGet("rule-delete").disabled = !simplemail.ruleTree.view.selection.getRangeCount();
}

// userok: rewrited
function editRule(add) {
  var aRule = add ? simplemail.overlay.storage.createRule(null, null, null, null, null, null) : simplemail.rules[simplemail.ruleTree.currentIndex];
  var param = { rule: aRule };
  openDialog("chrome://simplemail/content/preferences/filter/rule.xul", "simplemail-preferences-filter-rule-window", "chrome,centerscreen,modal,resizable", param);
  if (!param.rule) 
    return;

  if (add) {
    simplemail.rules.push(aRule);
    ruleTreeView.treebox.rowCountChanged(ruleTreeView.rowCount - 1, 1);
    simplemail.ruleTree.view.selection.select(ruleTreeView.rowCount - 1);
  } else {
    ruleTreeView.treebox.invalidateRow(simplemail.ruleTree.currentIndex);
  }
}

function deleteRules() {
  if (simplemail.confirm(simplemail.Bundle.getString("deleteRule"))) {
    ruleTreeView.forEachSelected(function(index) {
      simplemail.rules.splice(index, 1);
      ruleTreeView.treebox.rowCountChanged(index, -1);
    });
  }
}
