if (typeof(simplemail) == "undefined")
  var simplemail = {a: "preferences.js"};

// userok: filterTree  -> simplemail.filterTree
// userok: accountTree -> simplemail.accountTree

simplemail.SimpleMailPreferences = function() {
  var pub      = {};
  pub.account  = [],
  pub.accounts = [],
  pub.filters  = [],
  pub.messages = [],

  pub.initialize = function() {  // userok: rewrited
    //console.error("SM.SimpleMailPreferences_initialize", simplemail, simplemail.overlay);//userok_log
    simplemail.overlay                        = simplemail.getBrowserWindow().simplemail.overlay;
    simplemail.SimpleMailPreferences.accounts = simplemail.overlay.storage.getAccounts();
    simplemail.accountTree                    = simplemail.domGet("account-tree");
    simplemail.accountTree.view               = simplemail.accountTreeView;
    if (simplemail.accountTree.view.rowCount > 0) 
      simplemail.accountTree.view.selection.select(0);

    simplemail.SimpleMailPreferences.filters = simplemail.overlay.storage.getFilters();
    simplemail.filterTree                    = simplemail.domGet("filter-tree");
    simplemail.filterTree.view               = simplemail.filterTreeView;
    if (simplemail.filterTree.view.rowCount > 0) 
      simplemail.filterTree.view.selection.select(0);
    
    simplemail.domGet("checkOnStartup").checked        = simplemail.SimpleMailPrefs.getBool("checkOnStartup");
    simplemail.domGet("openInCurrentTab").checked      = simplemail.SimpleMailPrefs.getBool("openInCurrentTab");
    simplemail.domGet("moveToTrash").checked           = simplemail.SimpleMailPrefs.getBool("moveToTrash");
    simplemail.domGet("cleanonexit").checked           = simplemail.SimpleMailPrefs.getBool("cleanonexit");
    simplemail.domGet("confirmdelete").checked         = simplemail.SimpleMailPrefs.getBool("confirmdelete");
    simplemail.domGet("hideStatusNoMail").checked      = simplemail.SimpleMailPrefs.getBool("hideStatusNoMail");
    simplemail.domGet("hideNoMail").checked            = simplemail.SimpleMailPrefs.getBool("hideNoMail");
    simplemail.domGet("hideAll").checked               = simplemail.SimpleMailPrefs.getBool("hideAll");
    simplemail.domGet("headersOnly").checked           = simplemail.SimpleMailPrefs.getBool("headersOnly");
    simplemail.domGet("handleMailto").checked          = simplemail.SimpleMailPrefs.getBool("handleMailto"); // userok
    simplemail.domGet("newMessagesInWindow").checked   = simplemail.SimpleMailPrefs.getBool("newMessagesInWindow");
    simplemail.domGet("addressBookAddOnSend").checked  = simplemail.SimpleMailPrefs.getBool("addressBookAddOnSend");
    simplemail.domGet("plaintextOnSend").checked       = simplemail.SimpleMailPrefs.getBool("plaintextOnSend");
    simplemail.domGet("plaintextOnReceive").checked    = simplemail.SimpleMailPrefs.getBool("plaintextOnReceive");
    simplemail.domGet("markReadTimeout").value         = simplemail.SimpleMailPrefs.getInt("markReadTimeout");
    simplemail.domGet("dataDirectory").value           = simplemail.SimpleMailPrefs.getString("dataDirectory");
    simplemail.selectItem("popupNotification", simplemail.SimpleMailPrefs.getString("popupNotification"));
    simplemail.selectItem("sendreceiptresp", simplemail.SimpleMailPrefs.getString("sendreceiptresp"));
    var cbstylepopup = simplemail.domGet("stylepopup");
    if (simplemail.SimpleMailPrefs.getBool("transpopup"))
      cbstylepopup.selectedIndex = 0;
    else if (simplemail.SimpleMailPrefs.getBool("fullpopup"))
      cbstylepopup.selectedIndex = 1;
    else
      cbstylepopup.selectedIndex = 2;
    simplemail.domGet("popupTimeout").value = simplemail.SimpleMailPrefs.getInt("popupTimeout");
    var cbstyleicons = simplemail.domGet("styleicons");
    if (simplemail.SimpleMailPrefs.getBool("old"))
      cbstyleicons.selectedIndex = 0;
    else if (simplemail.SimpleMailPrefs.getBool("nuvola"))
      cbstyleicons.selectedIndex = 1;
    else if (simplemail.SimpleMailPrefs.getBool("oxygen"))
      cbstyleicons.selectedIndex = 2;
    else
      cbstyleicons.selectedIndex = 3;
    simplemail.domGet("formatDate").selectedIndex = (simplemail.SimpleMailPrefs.getBool("eu")) ? 0 : 1;                                          
    simplemail.domGet("newAttachs").checked        = simplemail.SimpleMailPrefs.getBool("newAttachs");
    simplemail.domGet("mailSound").checked         = simplemail.SimpleMailPrefs.getBool("mailSound");
    simplemail.domGet("mailSoundPath").value       = simplemail.SimpleMailPrefs.getString("mailSoundPath");
    simplemail.domGet("warningPlainText").checked  = simplemail.SimpleMailPrefs.getBool("warningPlainText");
    simplemail.domGet("cleandatabase").checked     = simplemail.SimpleMailPrefs.getBool("cleandatabase");
    simplemail.domGet("enableLog").checked         = simplemail.SimpleMailPrefs.getBool("enableLog");
    simplemail.domGet("popupOnTop").checked        = simplemail.SimpleMailPrefs.getBool("popupOnTop");
    var cbOpenMail = simplemail.domGet("openMail");
    if (simplemail.SimpleMailPrefs.getBool("messagesInWindow"))
      cbOpenMail.selectedIndex = 0;
    else if (simplemail.SimpleMailPrefs.getBool("messagesInTab"))
      cbOpenMail.selectedIndex = 1;
    else
      cbOpenMail.selectedIndex = 2;
    simplemail.SimpleMailPreferences.showBrowseSoundDirectory();
    simplemail.SimpleMailPreferences.statusDisabled();
    
    // userok: set version
    var preferencesVersion = simplemail.domGet("preferencesVersion");
    if (preferencesVersion)
      preferencesVersion.value = simplemail.overlay.addonVersion;
  },
  
  pub.onSelectAccount = function() {
    simplemail.domGet("account-edit").disabled =
    simplemail.domGet("account-delete").disabled = !simplemail.accountTree.view.selection.getRangeCount();
  },

  // userok: async
  pub.editAccount = function(add) {
    if (add)
      simplemail.SimpleMailPreferences.account = new simplemail.Account(null,null,null,null,null,60,null,null,null,null,null,0,null,110,null,null,null,25,null,null);
    else
      simplemail.SimpleMailPreferences.account = simplemail.SimpleMailPreferences.accounts[simplemail.accountTree.currentIndex];
    
    var param = { inn:{account: simplemail.SimpleMailPreferences.account }, out: null};
    openDialog("chrome://simplemail/content/preferences/account.xul", "simplemail-preferences-account-window", "chrome,centerscreen,modal,resizable=no", param);
    
    var account = simplemail.SimpleMailPreferences.account;
    if (param.out) {
      simplemail.overlay.storage.saveAccount(function(acc) {
        if (add) {
          simplemail.SimpleMailPreferences.accounts.push(acc);
          simplemail.accountTreeView.treebox.rowCountChanged(simplemail.accountTreeView.rowCount - 1, 1);
          simplemail.accountTree.view.selection.select(simplemail.accountTreeView.rowCount - 1);
        } else
          simplemail.accountTreeView.treebox.invalidateRow(simplemail.accountTree.currentIndex);   
      }, account);
    }
  },

  // userok: async
  pub.deleteAccounts = function() {
    var confirmText = simplemail.Bundle.getString("deleteAccounts");
    if (simplemail.confirm(confirmText)) {
      simplemail.accountTreeView.forEachSelected(function(index) {
        var ms = simplemail.overlay.storage.getAccountMessages(simplemail.SimpleMailPreferences.accounts[index].id);
        simplemail.SimpleMailPreferences.messages = simplemail.SimpleMailPreferences.messages.concat(ms);
      });
      if (simplemail.SimpleMailPreferences.messages.length) {
        var confirmText = simplemail.Bundle.getString("deleteAccountMessages");
        simplemail.overlay.askDeleteMail(simplemail.SimpleMailPreferences.messages, confirmText, window);
      }
      simplemail.accountTreeView.forEachSelected(function(index) {
        simplemail.overlay.storage.deleteAccount(function(acc, idx) {
          simplemail.SimpleMailPreferences.accounts.splice(idx, 1);
          simplemail.accountTreeView.treebox.rowCountChanged(idx, -1);          
        }, simplemail.SimpleMailPreferences.accounts[index], index);
      });
    }
  },

  pub.hideStatusNoMail = function(value) {
    simplemail.SimpleMailPrefs.setBool('hideStatusNoMail', value);
    simplemail.overlay.updateIcons();
  },

  pub.hideNoMail = function(value) {
    simplemail.SimpleMailPrefs.setBool('hideNoMail', value);
    simplemail.overlay.updateIcons();
  },

  pub.hideAll = function(value) {
    simplemail.SimpleMailPrefs.setBool('hideAll', value);
    simplemail.SimpleMailPreferences.statusDisabled();
    simplemail.overlay.updateIcons();
  },

  pub.statusDisabled = function () {
    if (simplemail.SimpleMailPrefs.getBool("hideAll")) {
      simplemail.domGet("hideStatusNoMail").disabled = true;
      simplemail.SimpleMailPrefs.clear('hideStatusNoMail');
    } else {
      simplemail.domGet("hideStatusNoMail").disabled = false;
      simplemail.SimpleMailPrefs.clear('hideAll');
    }
  },

  // userok: rewrited
  pub.stylepopup = function(selectedIndex) {
    switch (simplemail.domGet("stylepopup").selectedIndex) {
      case 0:
        simplemail.SimpleMailPrefs.setBool('transpopup', true);
        simplemail.SimpleMailPrefs.setBool('fullpopup', false);
        simplemail.SimpleMailPrefs.setBool('customPopup', true);
        break;
      case 1:
        simplemail.SimpleMailPrefs.setBool('transpopup', false);
        simplemail.SimpleMailPrefs.setBool('fullpopup', true);
        simplemail.SimpleMailPrefs.setBool('customPopup', true);      
        break;
      case 2:
        simplemail.SimpleMailPrefs.setBool('transpopup', false);
        simplemail.SimpleMailPrefs.setBool('fullpopup', false);
        simplemail.SimpleMailPrefs.setBool('customPopup', false);      
        break;
    }
  },

  pub.browseDataDirectory = function() {
    var file = simplemail.SimpleMailFile.chooseFile("folder");
    if (file) {
      simplemail.domGet("dataDirectory").value = file.path;
      simplemail.SimpleMailPrefs.setString("dataDirectory", file.path);
    }
  },

  pub.defaultDataDirectory = function() {
    simplemail.SimpleMailPrefs.clear("dataDirectory");
    simplemail.domGet("dataDirectory").value = simplemail.SimpleMailPrefs.getString("dataDirectory");
  },

  pub.showBrowseSoundDirectory = function(){
    if (!simplemail.SimpleMailPrefs.getBool("mailSound")) {
      simplemail.domGet("mailSoundPath").disabled   = true;
      simplemail.domGet("browseMailSound").disabled = true;
    } else {
      simplemail.domGet("mailSoundPath").disabled   = false;
      simplemail.domGet("browseMailSound").disabled = false;
    }
 },

  pub.browseSoundDirectory = function() {
    var file = simplemail.SimpleMailFile.chooseFile("open", ["*.wav"]);
    if (file) {
      simplemail.domGet("mailSoundPath").value = file.path;
      simplemail.SimpleMailPrefs.setString("mailSoundPath", file.path);
    }
  },

  // userok: rewrited
  pub.styleicons = function(selectedIndex) {
    switch (simplemail.domGet("styleicons").selectedIndex) {
      case 0:
        simplemail.SimpleMailPrefs.setBool('old', true);
        simplemail.SimpleMailPrefs.clear('nuvola');
        simplemail.SimpleMailPrefs.clear('oxygen');
        simplemail.SimpleMailPrefs.clear('australis');
        break;
      case 1:
        simplemail.SimpleMailPrefs.clear('old');
        simplemail.SimpleMailPrefs.setBool('nuvola', true);
        simplemail.SimpleMailPrefs.clear('oxygen');
        simplemail.SimpleMailPrefs.clear('australis');
        break;
      case 2:
        simplemail.SimpleMailPrefs.clear('old');
        simplemail.SimpleMailPrefs.clear('nuvola');
        simplemail.SimpleMailPrefs.setBool('oxygen', true);
        simplemail.SimpleMailPrefs.clear('australis');
        break;
      case 3:
        simplemail.SimpleMailPrefs.clear('old');
        simplemail.SimpleMailPrefs.clear('nuvola');
        simplemail.SimpleMailPrefs.clear('oxygen');
        simplemail.SimpleMailPrefs.setBool('australis', true);
        break;
    }
  },

  // userok: rewrited
  pub.formatDate = function(selectedIndex) {
    switch (simplemail.domGet("formatDate").selectedIndex) {
      case 0:
        simplemail.SimpleMailPrefs.setBool('eu', true);
        simplemail.SimpleMailPrefs.clear('us');
        break;
      case 1:
        simplemail.SimpleMailPrefs.setBool('us', true);
        simplemail.SimpleMailPrefs.clear('eu');
        break;
    }
  }, 

  // userok: rewrited
  pub.openMail = function(selectedIndex) {
    switch (simplemail.domGet("openMail").selectedIndex) {
      case 0:
        simplemail.SimpleMailPrefs.setBool('messagesInWindow', true);
        simplemail.SimpleMailPrefs.clear('messagesInTab');
        break;
      case 1:
        simplemail.SimpleMailPrefs.clear('messagesInWindow');
        simplemail.SimpleMailPrefs.setBool('messagesInTab', true);
        break;
      case 2:
        simplemail.SimpleMailPrefs.clear('messagesInTab');
        simplemail.SimpleMailPrefs.clear('messagesInWindow');
        break;
    }
  },

  pub.helpWindow = null,
  
  pub.onHelp = function() {
    simplemail.overlay.helpWindow = window.open("http://www.userlogos.org/forum/simplemail");
  }, 

  // userok: rewrited
  pub.onAccept = function() {
    //console.error("pref.onAccept1", simplemail, this);//userok_log
    if (!simplemail.domGet("mailSoundPath").value && simplemail.domGet("mailSound").checked) 
      simplemail.SimpleMailPrefs.setBool('mailSound', false); 
    // apply filter now
    if (simplemail.domGet("applyfilter").checked) {
      var taccounts = simplemail.overlay.storage.getAccounts();
      var msg       = [];
      for (var i = taccounts.length - 1; i >= 0; i--)
        msg = msg.concat(simplemail.overlay.storage.getAccountMessages(taccounts[i].id));

      if (msg) {
        var filterManager = new simplemail.FilterManager(simplemail.overlay.storage, msg);
        var len           = msg.length;
        var tfolders      = simplemail.overlay.storage.getFolders();
        var pId;
        for (var i = len - 1; i >= 0; i--) {
          // find parent folder
          for (var j in tfolders) {
            var children = tfolders[j];
            for (var k in children) {
              if (children[k].id == msg[i].folderId)
                var msgParentId = children[k].parentId;
            }
          }
          pId = 0;
          // for inbox\sent folders
          if (msg[i].folderId == simplemail.Filter.INBOX || msg[i].folderId == simplemail.Filter.SENT)
            pId = msg[i].folderId;
          // or for inbox\sent parent folders
          if (msgParentId == simplemail.Filter.INBOX || msgParentId == simplemail.Filter.SENT)
            pId = msgParentId;
          // exec filter
          if (pId) {
            var msgs = filterManager.execute(msg[i], pId);
            simplemail.overlay.storage.saveMessageState(msgs);    
          }
        }
      }
    }
    // userok: handle Mailto links
    simplemail.overlay.handleMailto();
    // ok
    return true;
  }
  
  //console.error("SM_prefs", this);//userok_log
  
  return pub;
}();

simplemail.accountTreeView = function() {
  var pub = {
    get rowCount() {
      return simplemail.SimpleMailPreferences.accounts.length;
    }
  };
    
  pub.getCellText = function(row, column) {
    var name = column.id.replace(/account-/, "");
    return simplemail.SimpleMailPreferences.accounts[row][name];
  },
  
  pub.getImageSrc = function(row, column) {
    if (column.id == "account-image")
      return simplemail.SimpleMailFile.getEnvelopeIconURL(simplemail.SimpleMailPreferences.accounts[row].color);
  },
  
  pub.action = function() {
    simplemail.SimpleMailPreferences.editAccount();
  },
  
  pub.delete = function() {
    simplemail.SimpleMailPreferences.deleteAccounts();
  },

  pub.canDrop = function(row, orientation, dataTransfer) { // userok: rewrited
    //console.error("SM.accountTreeView.canDrop", this, row, orientation, dataTransfer);//userok_log
    return dataTransfer.types.contains("text/plain");
  },
  
  pub.drop = function(row, orientation, dataTransfer) { // userok: rewrited
    //console.error("SM.accountTreeView.drop", this, row, orientation, dataTransfer);//userok_log
    if (orientation == this.DROP_AFTER)
      row++;

    var move = [];
    simplemail.accountTreeView.forEachSelected(function(index) {
      move.unshift(simplemail.SimpleMailPreferences.accounts[index]);
      simplemail.SimpleMailPreferences.accounts.splice(index, 1);
      simplemail.accountTreeView.treebox.rowCountChanged(index, -1);
      if (index < row) 
        row--;
    });
    simplemail.SimpleMailPreferences.accounts.splice.apply(simplemail.SimpleMailPreferences.accounts, [row, 0].concat(move));
    simplemail.accountTreeView.treebox.rowCountChanged(row, move.length);
    simplemail.overlay.storage.saveAccounts(simplemail.SimpleMailPreferences.accounts);
  }
  
  return pub;
}();  

simplemail.DefaultTreeView.extend(simplemail.accountTreeView);

simplemail.filterTreeView = function() {
  var pub = {
    get rowCount() {
      return simplemail.SimpleMailPreferences.filters.length;
    }
  };
  
  pub.getCellText = function(row, column) {
    var name  = column.id.replace(/filter-/, "");
    var value = simplemail.SimpleMailPreferences.filters[row][name];
    return simplemail.Bundle.getString(value) || value;
  },
  
  pub.action = function() {
    simplemail.filterTreeView.editFilter();
  },
  
  pub.delete = function() {
    simplemail.filterTreeView.deleteFilters();
  },

  pub.canDrop = function(row, orientation, dataTransfer) { // userok: rewrited
    //console.error("SM.filterTree.canDrop", this, row, orientation, dataTransfer);//userok_log
    return dataTransfer.types.contains("text/plain");
  },
  
  pub.drop = function(row, orientation, dataTransfer) { // userok: rewrited
    //console.error("SM.filterTree.drop", this, row, orientation, dataTransfer);//userok_log
    if (orientation == this.DROP_AFTER)
      row++;

    var move = [];
    simplemail.filterTreeView.forEachSelected(function(index) {
      move.unshift(simplemail.SimpleMailPreferences.filters[index]);
      simplemail.SimpleMailPreferences.filters.splice(index, 1);
      simplemail.filterTreeView.treebox.rowCountChanged(index, -1);
      if (index < row) 
        row--;
    });
    simplemail.SimpleMailPreferences.filters.splice.apply(simplemail.SimpleMailPreferences.filters, [row, 0].concat(move));
    simplemail.filterTreeView.treebox.rowCountChanged(row, move.length);
    simplemail.overlay.storage.saveFilters(simplemail.SimpleMailPreferences.filters); // userok: saveFilters uses async func saveFilter
  }

  return pub;
}();

simplemail.DefaultTreeView.extend(simplemail.filterTreeView);

simplemail.filterTreeView.onSelectFilter = function() {
  simplemail.domGet("filter-edit").disabled =
    simplemail.domGet("filter-delete").disabled = !simplemail.filterTree.view.selection.getRangeCount();
}

// userok: async
simplemail.filterTreeView.editFilter = function(add) {
  //console.error("SM.preference_editFilter", this);//userok_log
  if (add)
    var tfilter  = simplemail.overlay.storage.createFilter(null, null, '', simplemail.Filter.INBOX, [], []);
  else {
    var fltrIdx  = simplemail.filterTree.currentIndex;
    var fltrOrig = simplemail.SimpleMailPreferences.filters[fltrIdx];
    var tfilter  = simplemail.overlay.storage.createFilter(fltrOrig.id, fltrOrig.index, fltrOrig.name, fltrOrig.type, fltrOrig.rules.slice(), fltrOrig.actions.slice());
  }
  
  var param = { filter: tfilter };
  openDialog("chrome://simplemail/content/preferences/filter/filter.xul", "simplemail-preferences-filter-window", "chrome,centerscreen,modal,resizable", param);
  if (!param.filter)
    return;

  simplemail.overlay.storage.saveFilter(function(fltr) {
    if (add) {
      simplemail.SimpleMailPreferences.filters.push(fltr);
      simplemail.filterTreeView.treebox.rowCountChanged(simplemail.filterTreeView.rowCount - 1, 1);
      simplemail.filterTree.view.selection.select(simplemail.filterTreeView.rowCount - 1);
    } else {
      simplemail.SimpleMailPreferences.filters[fltrIdx] = fltr;
      simplemail.filterTreeView.treebox.invalidateRow(fltrIdx);
    }
  }, tfilter);
}

// userok: async
simplemail.filterTreeView.deleteFilters = function() {
  if (simplemail.confirm(simplemail.Bundle.getString("deleteFilter"))) {
    simplemail.filterTreeView.forEachSelected(function(index) {
      simplemail.overlay.storage.deleteFilter(function(filter, idx) {
        simplemail.SimpleMailPreferences.filters.splice(idx, 1);
        simplemail.filterTreeView.treebox.rowCountChanged(idx, -1);
      }, simplemail.SimpleMailPreferences.filters[index], index);
    });
  }
}

// userok: Drag-n-Drop
function OnDragStart(event) {
  if (event.target.nodeName != "treechildren") 
    return;
  //console.log("OnDragStart", event);//userok_log
  event.dataTransfer.effectAllowed = "move";
  event.dataTransfer.setData("text/plain", event.target.parentNode.id);
}