if (typeof(simplemail) == "undefined")
  var simplemail = {a: "utils.js"};

// userok: rewrited
simplemail.domGet = function(id) {
  return document.getElementById(id);
}
  
// userok: rewrited
simplemail.domRemove = function(id) {
  var el = simplemail.domGet(id);
  if (el)
    el.parentNode.removeChild(el);
}

simplemail.SimpleMailDate = function() {
  var pub = {};
  
  pub.toMIME = function(date) {
    date = new Date(date);
    return date.toString().replace(/(^\w+) (\w+) (\w+) (.*) GMT(.*)/, "$1, $3 $2 $4 $5");
  },

  pub.toString = function(date) {
    date = new Date(date);
    if (!date.getTime()) return "";

    var timeZone = - date.getTimezoneOffset() / 60;
    if (simplemail.SimpleMailPrefs.getBool("eu")) {
      return simplemail.pad(date.getDate()) + "/" +
           simplemail.pad(date.getMonth() + 1) + "/" +
           date.getFullYear().toString().substr(2) + " " +
           simplemail.pad(date.getHours()) + ":" +
           simplemail.pad(date.getMinutes()) + ":" +
           simplemail.pad(date.getSeconds());    
    } else { 
      return simplemail.pad(date.getMonth() + 1) + "/" +
           simplemail.pad(date.getDate()) + "/" +
           date.getFullYear().toString().substr(2) + " " +
           simplemail.pad(date.getHours()) + ":" +
           simplemail.pad(date.getMinutes()) + ":" +
           simplemail.pad(date.getSeconds());
    }
  },

  pub.toShortString = function(date) {
    date = new Date(date);
    if (!date.getTime()) return "";

    var timeZone = - date.getTimezoneOffset() / 60;
    return simplemail.pad(date.getDate()) + "/" +
           simplemail.pad(date.getMonth() + 1) + "/" +
           date.getFullYear().toString().substr(2);
  },

  pub.toGMT = function(date) {
    date = new Date(date);
    if (!date.getTime()) return "";

    var gmt = new Date(date.getTime() + date.getTimezoneOffset() * 60 * 1000);
    return gmt.getFullYear() + "-" +
           simplemail.pad(gmt.getMonth() + 1) + "-" +
           simplemail.pad(gmt.getDate()) + " " +
           simplemail.pad(gmt.getHours()) + ":" +
           simplemail.pad(gmt.getMinutes()) + ":" +
           simplemail.pad(gmt.getSeconds()) + " GMT";
  },

  pub.timePassed = function(date) {
    if (date) {
      var seconds = Math.floor((new Date() - date) / 1000);
      var hours = Math.floor(seconds / 3600);
      seconds = seconds - hours * 3600;
      var minutes = Math.floor(seconds / 60);
      seconds = seconds - minutes * 60;
      return simplemail.pad(hours) + ":" +
             simplemail.pad(minutes) + ":" +
             simplemail.pad(seconds);
    }
  },

  pub.parse = function(date) {
    // Convert short year to full
    date = date.replace(/(\w+, \d+ \w+) (\d{2}) /, "$1 20$2 ");
    return Date.parse(date);
  }
  return pub;
}();

// userok: rewrited_class
simplemail.logTime = function() {
  var timePassed = '';
  try {
    var end     = new Date();
    var endTime = end.getTime();
    var elapsed = new String(endTime - this.lastTime); // Time in milliseconds
    timePassed  = '[' + elapsed + ' ms]   ';
    this.lastTime = endTime; // Remember last time
  } catch(e) {;}
  return end.getHours() + ':' + end.getMinutes() + ':' + end.getSeconds() + '.' + end.getMilliseconds() + '  ' + timePassed;
};

// userok: rewrited
simplemail.logToConsole = function (msg, optionTitle) {
  var csrv = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
  csrv.logStringMessage("SimpleMail : " + this.logTime() + "\n" + msg);
};

simplemail.pad = function(number) {
  return (number < 10) ? "0" + number : number;
};

// Make a reversed copy of an array, preserving keys
simplemail.reverse = function(array) {
  var reverseKeys = [];
  for (var i in array)
    reverseKeys.unshift(i);

  var result = new Object();
  for (var i in reverseKeys) {
    var key     = reverseKeys[i];
    result[key] = array[key];
  }
  return result;
};

simplemail.merge = function(array1, array2) {
  var result = [];
  for (var i in array1)
    result[i] = array1[i];

  for (var i in array2) {
    if (array2[i] != null) 
      result[i] = array2[i];
  }
  return result;
};

simplemail.clearElement = function(el) {
  for (var i = el.childNodes.length - 1; i >= 0; i--)
    el.removeChild(el.childNodes[i]);
};

// userok
simplemail.getPromptService = function() {
  return Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
};

// userok: rewrited
simplemail.alert = function(message, title) {
  var prompts = this.getPromptService();
  return prompts.alert(window, title || "Simple Mail", message);
};

// userok: rewrited
simplemail.confirm = function(message, wnd) {
  var prompts = this.getPromptService();
  return prompts.confirm(wnd || window, "Simple Mail", message);
};

// userok: rewrited
simplemail.confirmCheck = function(message, checkMessage, check, wnd) {
  var prompts = this.getPromptService();
  return prompts.confirmCheck(wnd || window, "Simple Mail", message, checkMessage, check);
};

// userok: rewrited
simplemail.prompt = function(message, value) {
  var prompts = this.getPromptService();
  var amsg    = (simplemail.Bundle.getString(message) || message) + ":";
  return prompts.prompt(window, "Simple Mail", amsg, value, null, { value: false });
};

simplemail.promptPassword = function(email, savePassword) {
  var password = { value: "" };
  var check    = { value: false };
  var prompts  = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
  var message  = simplemail.Bundle.getString("enterPasswordFor", [ email ]) + ":";
  prompts.promptPassword(window, "Simple Mail", message, password, simplemail.Bundle.getString("savePassword"), check);

  if (check.value && savePassword) 
    savePassword(password.value);
  return password.value;
};

// userok: rewrited
simplemail.error = function(message, params) {
  var amsg          = simplemail.Bundle.getString(message, params);
  var messageType   = "error";
  var accountError  = simplemail.SimpleMailPrefs.getString('accountError');
  var browserWindow = simplemail.getBrowserWindow();
  simplemail.SimpleMailPopup.open("chrome://simplemail/skin/status/errors_large.png",
               "Simple Mail - " + accountError, amsg, browserWindow.toJavaScriptConsole, messageType);
  amsg = "Simple Mail : " + amsg;
  // Write log file
  var today = new Date().getTime();
  var date = simplemail.SimpleMailDate.toString(today);
  var date = date.replace(/\//g,"-");
  var dataLog = "";
  if (simplemail.SimpleMailPrefs.getBool("enableLog")) {
    var logFile = simplemail.SimpleMailFile.createLogFile();
    var out = simplemail.SimpleMailFile.createOutputStream2(logFile);
    out.write("\r\n", 2);
    out.write(date + " ERROR: " + amsg);
    out.write("\r\n", 2);
    out.close();
  }
  return amsg;
};

simplemail.getBrowserWindow = function() {
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
  return wm.getMostRecentWindow("navigator:browser");
};

simplemail.getBrowser = function() {
  return this.getBrowserWindow().getBrowser();
};

simplemail.getDocumentTab = function(doc) {
  var gBrowser = simplemail.getBrowser();
  var tabs     = gBrowser.tabContainer.childNodes;
  var len      = tabs.length;
  for (var i = 0; i < len; i++) {
    if (tabs[i].linkedBrowser.contentDocument == doc)
      return tabs[i];
  }
};

simplemail.toJSON = function(object, indent, level) {
  if (!level) 
    level = 0;
  if (!indent) 
    indent = " ";
  
  var json = JSON.stringify(object);
  return level ? json : json ;
};

simplemail.whereToOpenLink = function(event) {
  if (!event) 
    return "";

  if (!event.button) {
    return event.shiftKey ? (event.ctrlKey ? "tabshifted" : "window")
                          : (event.ctrlKey ? "tab" : "");
  } else if (event.button == 1) {
    return event.shiftKey ? "tab" : "tabshifted";
  }
};

// Works in both FF & SeaMonkey
simplemail.openUILink = function(url, where) {
  if (where instanceof Event)
    var where = simplemail.whereToOpenLink(where);

  switch (where) {
    case "tabshifted": return gBrowser.addTab(url);
    case "tab":        return gBrowser.selectedTab = gBrowser.addTab(url);
    case "window":     return open(url);
    default:           return loadURI(url);
  }
};

simplemail.md5 = function(string) {
  // Build array of character codes to MD5
  var array = [];
  var len   = string.length;
  for (var i = 0; i < len; i++)
    array.push(string.charCodeAt(i));

  var hash = Components.classes["@mozilla.org/security/hash;1"].createInstance(Components.interfaces.nsICryptoHash);
  hash.init(hash.MD5);
  hash.update(array, array.length);
  var binary = hash.finish(false);

  // Unpack the binary data bin2hex style
  var result = "";
  for (var i = 0; i < binary.length; ++i) {
    var c = binary.charCodeAt(i);
    var ones = c % 16;
    var tens = c >> 4;
    result += String.fromCharCode(tens + (tens > 9 ? 87 : 48)) +
              String.fromCharCode(ones + (ones > 9 ? 87 : 48));
  }
  return result;
};

simplemail.size2string = function(value) {
  return value >= 1000000 ? (value / 1000000).toFixed(1) + " " + simplemail.Bundle.getString("mb") :
         value >= 1024 ? (value / 1024).toFixed(1) + " " + simplemail.Bundle.getString("kb")
                       : value + " " + simplemail.Bundle.getString("bytes");
};

simplemail.lastUniqueId = 0;

simplemail.getUniqueId = function() {
  return simplemail.lastUniqueId = Math.max(simplemail.lastUniqueId + 1, new Date().getTime());
};

simplemail.getFontList = function() {
  var enumerator = Components.classes["@mozilla.org/gfx/fontenumerator;1"]
                   .getService(Components.interfaces.nsIFontEnumerator);
  var count = { value: 0 };
  return enumerator.EnumerateAllFonts(count);
};

// userok: rewrited (Select item in menulist)
simplemail.selectItem = function(menulistId, value, add) {
  var vl    = value;
  var popup = simplemail.domGet(menulistId).menupopup;
  var len   = popup.childNodes.length;
  for (var i = 0; i < len; i++) {
    var l = (popup.childNodes[i].label);
    var v = (popup.childNodes[i].value);
    if (vl == l || vl == v) {
      popup.parentNode.selectedIndex = i;
      return;
    }
  }
  if (add && value) {
    var menuitem = popup.ownerDocument.createElement("menuitem");
    menuitem.setAttribute("label", value);
    menuitem.setAttribute("value", value);
    popup.parentNode.selectedItem = popup.appendChild(menuitem);
  } else 
    popup.parentNode.selectedIndex = 0;
};

// userok: rewrited
simplemail.getDefaultCharsets = function() {
  return [ // userok: array from CharsetMenu.jsm
    // Globally relevant
    "UTF-8",
    "windows-1252",
    // Arabic
    "windows-1256",
    "ISO-8859-6",
    // Baltic
    "windows-1257",
    "ISO-8859-4",
    // "ISO-8859-13", // Hidden since not in menu in IE11
    // Central European
    "windows-1250",
    "ISO-8859-2",
    // Chinese, Simplified
    "gbk",
    // Chinese, Traditional
    "Big5",
    // Cyrillic
    "windows-1251",
    "ISO-8859-5",
    "KOI8-R",
    "KOI8-U",
    "IBM866", // Not in menu in Chromium. Maybe drop this?
    // "x-mac-cyrillic", // Not in menu in IE11 or Chromium.
    // Greek
    "windows-1253",
    "ISO-8859-7",
    // Hebrew
    "windows-1255",
    "ISO-8859-8",
    // Japanese
    "Shift_JIS",
    "EUC-JP",
    "ISO-2022-JP",
    // Korean
    "EUC-KR",
    // Thai
    "windows-874",
    // Turkish
    "windows-1254",
    // Vietnamese
    "windows-1258",
    // Hiding rare European encodings that aren't in the menu in IE11 and would
    // make the menu messy by sorting all over the place
    // "ISO-8859-3",
    // "ISO-8859-10",
    // "ISO-8859-14",
    // "ISO-8859-15",
    // "ISO-8859-16",
    // "macintosh"
  ];
};

// userok
simplemail.getParser = function() {
  return Components.classes["@mozilla.org/parserutils;1"].getService(Components.interfaces.nsIParserUtils);
};

// userok: rewrited, obsolete dropped (FF < 14, SeaMonkey < 2.11)
simplemail.parseHTML = function(doc, html, allowStyle, blockMedia) {
  var parser = this.getParser();
  return parser.parseFragment(html, (blockMedia ? parser.SanitizerDropMedia : 0) | (allowStyle ? parser.SanitizerAllowStyle : 0), false, null, doc.documentElement);
};

// userok: rewrited
simplemail.htmlToText = function(html, flag, col) {
  var parser = this.getParser();
  return parser.convertToPlainText(html, flag, col);
};

// userok: rewrited
simplemail.sanitizeHtml = function(html, allowStyle) {
  var parser = this.getParser();
  return parser.sanitize(html, allowStyle ? parser.SanitizerAllowStyle : 0);
};

// userok
simplemail.showAlertNotification = function(text, title, imgurl) {
  //console.error("SM.showAlertNotification", text, title, imgurl);//userok_log
  try {
    Components.classes['@mozilla.org/alerts-service;1'].getService(Components.interfaces.nsIAlertsService).showAlertNotification(imgurl, title, text, false, '', null);      
  } catch (e) {
    // This can fail on Mac OS X
    var win = Components.classes['@mozilla.org/embedcomp/window-watcher;1'].getService(Components.interfaces.nsIWindowWatcher).openWindow(null, 'chrome://global/content/alerts/alert.xul', '_blank', 'chrome,titlebar=no,popup=yes', null);
    win.arguments = [imgurl, title, text, false, ''];          
  }
};

simplemail.SimpleMailText = function () {
  var pub = {};

  pub.REGEXP_URL  = /(https?:\/\/|ftp:\/\/|mailto:)[^\s<>\[\]\(\){}]*/gi,
  pub.REGEXP_LINK = /<img[\s\S]*?src=['"](.*?)['"][\s\S]*?>|<a[\s\S]*?href=['"](.*?)['"][\s\S]*?<\/a>/gi,

  pub.getURL = function(text) {
    var match = ("" + text).match(simplemail.SimpleMailText.REGEXP_URL);
    return match && match[0];
  },

  pub.toHtml = function(text) {
    return text.replace(/</g, "&lt;")
               .replace(/\r?\n/g, "<br>")
               .replace(simplemail.SimpleMailText.REGEXP_URL, function(url) {
                if (simplemail.SimpleMailPrefs.getBool("plaintextOnSend")) {
                  return url;
                } else {
                  return "<a href='" + url + "'>" + url + "</a>";
                } 
    });
  },
  
    
  pub.linkToLink = function(html) {
    return html.replace(simplemail.SimpleMailText.REGEXP_URL, function(url) {
      return "<a href='" + url + "'>" + url + "</a>";
    });
  },

  pub.linkToText = function(html, onUrl) {
    return simplemail.SimpleMailText.replaceURLs(html, function(text, url) {
      if (text.match(/href\=\"simplemail\:\/\/attachments/gim)) {
        return  text;
      } else { 
        return  url;
      }
    });
  },

  pub.replaceURLs = function(text, onUrl) {
    return text.replace(simplemail.SimpleMailText.REGEXP_LINK, function(text, image, anchor) {
      return onUrl(text, image || anchor, image);
    });
  },

  pub.replaceURLs2 = function(text, onUrl) {
    return text.replace(simplemail.SimpleMailText.REGEXP_URL, function(text) {
      return onUrl(text);
    });
  },

  pub.imageToLink = function(html) {
    return simplemail.SimpleMailText.replaceURLs(html, function(text, url, isImage) {
      return isImage ? "<a href='" + url + "'>" + text + "</a>" : text;
    });
  },

  pub.trim = function(string) {
    return string.replace(/^\s+|\s+$/g, "");
  },

  pub.toUnicode = function(text, charset) {
    try {
      if (!charset) return text;
      var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
                      .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
      converter.charset = charset;
      return converter.ConvertToUnicode(text);
    }
    catch(e) {
      simplemail.error("encodingError");
      throw e;
    }
  },

  pub.fromUnicode = function(text, charset) {
    try {
      if (!charset) return text;
      var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
                      .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
      converter.charset = charset;
      var result = converter.ConvertFromUnicode(text);
      return result + converter.Finish();
    }
    catch(e) {
      simplemail.error("encodingError");
      throw e;
    }
  },

  pub.getSelectedHtml = function(doc) {
    var selection = doc.defaultView.getSelection();
    if (selection.rangeCount) {
      var fragment = selection.getRangeAt(0).cloneContents();
      var div = doc.createElement("div");
      div.appendChild(fragment);
      return div.innerHTML;
    }
  },

  // Highlight given phrase, skipping html tags & entities
  pub.highlight = function(phrase, html) {
    var regexp = new RegExp("(<[\\s\\S]*?>|&.*?;)|(" + phrase + ")", "gi");
    return html.replace(regexp, function($0, $1, $2) {
      return $1 || "<span class='highlight'>" + $2 + "</span>";
    });
  }
  return pub;
}();

simplemail.SimpleMailPopup = function () {
  var pub = {};

  pub.TIMEOUT = function(){
  return simplemail.SimpleMailPrefs.getInt("popupTimeout") * 1000;
  },
  
  pub.queue = [],
  pub.inProgress = false,

  pub.open = function(image, title, text, onClick, messageType) {
    simplemail.SimpleMailPopup.queue.push({
      image: image,
      title: title,
      text: text,
      onClick: onClick,
      messageType: messageType
    });
    
    var gBrowser = simplemail.getBrowser();
    var len = gBrowser.browsers.length;  
    for(var i = 0; i < len; i++) {
      var browser = gBrowser.browsers[i];
      var uri = browser.currentURI.spec.replace (/(\?).*?/ig, "");
      var uri = uri.replace(/([0-9]).*?/ig, "");
    }

    if (!simplemail.SimpleMailPrefs.getBool("popupOnTop")) {
      var actualWindow = simplemail.overlay.testTabUrl("chrome://simplemail/content/main/main.xul") || uri == "chrome://simplemail/content/newmessage.xul";
      if (actualWindow){
        simplemail.SimpleMailPopup.showNext();
      } else return;
    } else {
      simplemail.SimpleMailPopup.showNext();
    }
  },

  pub.showNext = function() {
    if (simplemail.SimpleMailPopup.inProgress) return;
    
    var item = simplemail.SimpleMailPopup.queue.shift();
    if (!item) return;
  
    simplemail.SimpleMailPopup.inProgress = true;
  
    if (simplemail.SimpleMailPrefs.getBool("customPopup")) simplemail.SimpleMailPopup.showCustomPopup(item);
    else simplemail.SimpleMailPopup.showStandardPopup(item);
  
    setTimeout(function() {
      simplemail.SimpleMailPopup.inProgress = false;
      simplemail.SimpleMailPopup.showNext();
    },
    simplemail.SimpleMailPopup.TIMEOUT);
  },

  pub.showCustomPopup = function(item) {
    var wnd = simplemail.getBrowserWindow();
    wnd.openDialog(
      "chrome://simplemail/content/customnotify.xul", "customnotify-window",
      "chrome,dependent,titlebar=no", item.image, item.title, item.text, simplemail.SimpleMailPopup.TIMEOUT,
      function() {
        simplemail.SimpleMailPopup.queue = [];
        if (item.onClick) item.onClick();
      }, item.messageType
    );
  },

  pub.showStandardPopup = function(item) {
    var wnd = simplemail.getBrowserWindow(); 
    wnd.openDialog(
      "chrome://simplemail/content/classicnotify.xul", "classicnotify-window",
      "chrome,popup=yes,titlebar=no", item.image, item.title, item.text, true, null,
      function() {
        var listener = {
          observe: function(subject, topic) {
            if (topic == "alertclickcallback") {
              simplemail.SimpleMailPopup.queue = [];
              if (item.onClick) item.onClick(); 
            }
          }
        }
      }
    );
  }
  return pub;
}();

simplemail.Bundle = function() {
  var pub = {};

  pub.bundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://simplemail/locale/simplemail.properties"),

  pub.getString = function(name, params) {
    try {
      return params ? simplemail.Bundle.bundle.formatStringFromName(name, params, params.length)
                    : simplemail.Bundle.bundle.GetStringFromName(name);
    } catch(e) {
      return null;
    }
  }
  return pub;
}();